/* IconManager.c generated by valac 0.38.10, the Vala compiler
 * generated from IconManager.vala, do not modify */

/*
 * IconManager.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define TYPE_ICON_MANAGER (icon_manager_get_type ())
#define ICON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_MANAGER, IconManager))
#define ICON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_MANAGER, IconManagerClass))
#define IS_ICON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_MANAGER))
#define IS_ICON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_MANAGER))
#define ICON_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_MANAGER, IconManagerClass))

typedef struct _IconManager IconManager;
typedef struct _IconManagerClass IconManagerClass;
typedef struct _IconManagerPrivate IconManagerPrivate;
enum  {
	ICON_MANAGER_0_PROPERTY,
	ICON_MANAGER_NUM_PROPERTIES
};
static GParamSpec* icon_manager_properties[ICON_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))

struct _IconManager {
	GObject parent_instance;
	IconManagerPrivate * priv;
};

struct _IconManagerClass {
	GObjectClass parent_class;
};


static gpointer icon_manager_parent_class = NULL;
extern GtkIconTheme* icon_manager_theme;
GtkIconTheme* icon_manager_theme = NULL;
extern GeeArrayList* icon_manager_search_paths;
GeeArrayList* icon_manager_search_paths = NULL;
extern gboolean GTK_INITIALIZED;

GType icon_manager_get_type (void) G_GNUC_CONST;
#define ICON_MANAGER_SHIELD_ICON_SIZE 64
#define ICON_MANAGER_GENERIC_ICON_IMAGE "image-x-generic"
#define ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING "image-missing"
#define ICON_MANAGER_GENERIC_ICON_VIDEO "video-x-generic"
#define ICON_MANAGER_GENERIC_ICON_FILE "text-x-preview"
#define ICON_MANAGER_GENERIC_ICON_ARCHIVE_FILE "package-x-generic"
#define ICON_MANAGER_GENERIC_ICON_DIRECTORY "folder"
#define ICON_MANAGER_GENERIC_ICON_ISO "media-cdrom"
#define ICON_MANAGER_GENERIC_ICON_PDF "application-pdf"
#define ICON_MANAGER_ICON_HARDDRIVE "drive-harddisk"
#define ICON_MANAGER_SHIELD_LIVE "media-optical"
#define ICON_MANAGER_SHIELD_LOW "timeshift-shield-low"
#define ICON_MANAGER_SHIELD_MED "timeshift-shield-med"
#define ICON_MANAGER_SHIELD_HIGH "timeshift-shield-high"
void icon_manager_init (gchar** args, int args_length1, const gchar* app_name);
void tee_jee_logging_log_debug (const gchar* message);
gchar* tee_jee_file_system_file_resolve_executable_path (const gchar* file_path);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1, const gchar* path2);
void icon_manager_refresh_icon_theme (void);
GdkPixbuf* icon_manager_lookup (const gchar* icon_name, gint icon_size, gboolean symbolic, gboolean use_hardcoded, gint scale);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
GdkPixbuf* icon_manager_load_pixbuf_from_file (const gchar* file_path, gint icon_size);
GtkImage* icon_manager_lookup_image (const gchar* icon_name, gint icon_size, gboolean symbolic, gboolean use_hardcoded);
cairo_surface_t* icon_manager_lookup_surface (const gchar* icon_name, gint icon_size, gint scale, gboolean symbolic, gboolean use_hardcoded);
GdkPixbuf* icon_manager_lookup_gicon (GIcon* gicon, gint icon_size);
GtkImage* icon_manager_lookup_animation (const gchar* gif_name);
GdkPixbuf* icon_manager_add_emblem (GdkPixbuf* pixbuf, const gchar* icon_name, gint emblem_size, gboolean emblem_symbolic, GtkCornerType corner_type);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
GdkPixbuf* icon_manager_add_overlay (GdkPixbuf* pixbuf_base, GdkPixbuf* pixbuf_overlay);
GdkPixbuf* icon_manager_resize_icon (GdkPixbuf* pixbuf_image, gint icon_size);
GdkPixbuf* icon_manager_add_transparency (GdkPixbuf* pixbuf, gint opacity);
IconManager* icon_manager_new (void);
IconManager* icon_manager_construct (GType object_type);
static void icon_manager_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


void icon_manager_init (gchar** args, int args_length1, const gchar* app_name) {
	GeeArrayList* _tmp0_;
	gchar* binpath = NULL;
	gchar** _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* path = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gboolean _tmp10_;
	gchar* base_path = NULL;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_if_fail (app_name != NULL);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	tee_jee_logging_log_debug ("IconManager: init()");
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_object_unref0 (icon_manager_search_paths);
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	icon_manager_search_paths = _tmp0_;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = args;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1__length1 = args_length1;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _tmp1_[0];
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp3_ = tee_jee_file_system_file_resolve_executable_path (_tmp2_);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	binpath = _tmp3_;
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp4_ = binpath;
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp5_ = g_strdup_printf ("bin_path: %s", _tmp4_);
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp6_ = _tmp5_;
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	tee_jee_logging_log_debug (_tmp6_);
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_free0 (_tmp6_);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp7_ = app_name;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp8_ = g_strdup_printf ("/usr/share/%s/images", _tmp7_);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	path = _tmp8_;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp9_ = path;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp10_ = tee_jee_file_system_dir_exists (_tmp9_);
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp10_) {
#line 187 "IconManager.c"
		GeeArrayList* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp11_ = icon_manager_search_paths;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp12_ = path;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp13_ = path;
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp14_ = g_strdup_printf ("found images directory: %s", _tmp13_);
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp15_ = _tmp14_;
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp15_);
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_free0 (_tmp15_);
#line 209 "IconManager.c"
	}
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp16_ = binpath;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp17_ = tee_jee_file_system_file_parent (_tmp16_);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp18_ = _tmp17_;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp19_ = tee_jee_file_system_file_parent (_tmp18_);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp20_ = _tmp19_;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp21_ = tee_jee_file_system_file_parent (_tmp20_);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp22_ = _tmp21_;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_free0 (_tmp20_);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_free0 (_tmp18_);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	base_path = _tmp22_;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp23_ = base_path;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (g_strcmp0 (_tmp23_, "/") != 0) {
#line 235 "IconManager.c"
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gboolean _tmp31_;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp24_ = base_path;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp25_ = g_strdup_printf ("base_path: %s", _tmp24_);
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp26_ = _tmp25_;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp26_);
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_free0 (_tmp26_);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp27_ = base_path;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp28_ = path;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp29_ = tee_jee_file_system_path_combine (_tmp27_, _tmp28_);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_free0 (path);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		path = _tmp29_;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp30_ = path;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp31_ = tee_jee_file_system_dir_exists (_tmp30_);
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		if (_tmp31_) {
#line 270 "IconManager.c"
			GeeArrayList* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp32_ = icon_manager_search_paths;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp33_ = path;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp34_ = path;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp35_ = g_strdup_printf ("found images directory: %s", _tmp34_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp36_ = _tmp35_;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			tee_jee_logging_log_debug (_tmp36_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_free0 (_tmp36_);
#line 292 "IconManager.c"
		}
	}
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	icon_manager_refresh_icon_theme ();
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_free0 (base_path);
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_free0 (path);
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_free0 (binpath);
#line 303 "IconManager.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 310 "IconManager.c"
}


void icon_manager_refresh_icon_theme (void) {
	gboolean _tmp0_;
	GtkIconTheme* _tmp1_;
	GtkIconTheme* _tmp2_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = GTK_INITIALIZED;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (!_tmp0_) {
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return;
#line 324 "IconManager.c"
	}
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = gtk_icon_theme_get_default ();
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_object_unref0 (icon_manager_theme);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	icon_manager_theme = _tmp2_;
#line 334 "IconManager.c"
	{
		GeeArrayList* _path_list = NULL;
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		gint _path_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _path_index = 0;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp3_ = icon_manager_search_paths;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_path_list = _tmp4_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp5_ = _path_list;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp7_ = _tmp6_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_path_size = _tmp7_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_path_index = -1;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		while (TRUE) {
#line 362 "IconManager.c"
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gchar* path = NULL;
			GeeArrayList* _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			GtkIconTheme* _tmp14_;
			const gchar* _tmp15_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp8_ = _path_index;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_path_index = _tmp8_ + 1;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp9_ = _path_index;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp10_ = _path_size;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				break;
#line 384 "IconManager.c"
			}
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp11_ = _path_list;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp12_ = _path_index;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			path = (gchar*) _tmp13_;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp14_ = icon_manager_theme;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp15_ = path;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			gtk_icon_theme_append_search_path (_tmp14_, _tmp15_);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_free0 (path);
#line 402 "IconManager.c"
		}
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (_path_list);
#line 406 "IconManager.c"
	}
}


GdkPixbuf* icon_manager_lookup (const gchar* icon_name, gint icon_size, gboolean symbolic, gboolean use_hardcoded, gint scale) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	pixbuf = NULL;
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = icon_name;
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = strlen (_tmp0_);
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _tmp1_;
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp2_ == 0) {
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = NULL;
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 437 "IconManager.c"
	}
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp3_ = use_hardcoded;
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (!_tmp3_) {
#line 443 "IconManager.c"
		{
			GdkPixbuf* _tmp4_ = NULL;
			GtkIconTheme* _tmp5_;
			const gchar* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp5_ = icon_manager_theme;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp6_ = icon_name;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp7_ = icon_size;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp8_ = scale;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp9_ = gtk_icon_theme_load_icon_for_scale (_tmp5_, _tmp6_, _tmp7_, _tmp8_, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error_);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp4_ = _tmp9_;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 467 "IconManager.c"
				goto __catch55_g_error;
			}
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp10_ = _tmp4_;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp4_ = NULL;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			pixbuf = _tmp10_;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp11_ = pixbuf;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (_tmp11_ != NULL) {
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				result = pixbuf;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				_g_object_unref0 (_tmp4_);
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				return result;
#line 488 "IconManager.c"
			}
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (_tmp4_);
#line 492 "IconManager.c"
		}
		goto __finally55;
		__catch55_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			e = _inner_error_;
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp12_ = e;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp13_ = _tmp12_->message;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			tee_jee_logging_log_debug (_tmp13_);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_error_free0 (e);
#line 512 "IconManager.c"
		}
		__finally55:
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			return NULL;
#line 525 "IconManager.c"
		}
	}
	{
		GeeArrayList* _search_path_list = NULL;
		GeeArrayList* _tmp14_;
		GeeArrayList* _tmp15_;
		gint _search_path_size = 0;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _search_path_index = 0;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp14_ = icon_manager_search_paths;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_search_path_list = _tmp15_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp16_ = _search_path_list;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp18_ = _tmp17_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_search_path_size = _tmp18_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_search_path_index = -1;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		while (TRUE) {
#line 555 "IconManager.c"
			gint _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gchar* search_path = NULL;
			GeeArrayList* _tmp22_;
			gint _tmp23_;
			gpointer _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar** _tmp29_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp19_ = _search_path_index;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_search_path_index = _tmp19_ + 1;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp20_ = _search_path_index;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp21_ = _search_path_size;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (!(_tmp20_ < _tmp21_)) {
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				break;
#line 580 "IconManager.c"
			}
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp22_ = _search_path_list;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp23_ = _search_path_index;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, _tmp23_);
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			search_path = (gchar*) _tmp24_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp25_ = g_strdup (".svg");
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp26_ = g_strdup (".png");
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp27_ = g_strdup (".jpg");
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp28_ = g_strdup (".gif");
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp29_ = g_new0 (gchar*, 4 + 1);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp29_[0] = _tmp25_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp29_[1] = _tmp26_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp29_[2] = _tmp27_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp29_[3] = _tmp28_;
#line 608 "IconManager.c"
			{
				gchar** ext_collection = NULL;
				gint ext_collection_length1 = 0;
				gint _ext_collection_size_ = 0;
				gint ext_it = 0;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				ext_collection = _tmp29_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				ext_collection_length1 = 4;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				for (ext_it = 0; ext_it < 4; ext_it = ext_it + 1) {
#line 620 "IconManager.c"
					gchar* _tmp30_;
					gchar* ext = NULL;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
					_tmp30_ = g_strdup (ext_collection[ext_it]);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
					ext = _tmp30_;
#line 627 "IconManager.c"
					{
						gchar* img_file = NULL;
						const gchar* _tmp31_;
						const gchar* _tmp32_;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
						const gchar* _tmp38_;
						gboolean _tmp39_;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp31_ = search_path;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp32_ = icon_name;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp33_ = ext;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp34_ = g_strconcat (_tmp32_, _tmp33_, NULL);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp35_ = _tmp34_;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp36_ = tee_jee_file_system_path_combine (_tmp31_, _tmp35_);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp37_ = _tmp36_;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_g_free0 (_tmp35_);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						img_file = _tmp37_;
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp38_ = img_file;
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp39_ = tee_jee_file_system_file_exists (_tmp38_);
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						if (_tmp39_) {
#line 663 "IconManager.c"
							const gchar* _tmp40_;
							gint _tmp41_;
							GdkPixbuf* _tmp42_;
							GdkPixbuf* _tmp43_;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_tmp40_ = img_file;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_tmp41_ = icon_size;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_tmp42_ = icon_manager_load_pixbuf_from_file (_tmp40_, _tmp41_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_g_object_unref0 (pixbuf);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							pixbuf = _tmp42_;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_tmp43_ = pixbuf;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							if (_tmp43_ != NULL) {
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
								result = pixbuf;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
								_g_free0 (img_file);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
								_g_free0 (ext);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
								ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
								_g_free0 (search_path);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
								_g_object_unref0 (_search_path_list);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
								return result;
#line 696 "IconManager.c"
							}
						}
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_g_free0 (img_file);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_g_free0 (ext);
#line 703 "IconManager.c"
					}
				}
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 708 "IconManager.c"
			}
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_free0 (search_path);
#line 712 "IconManager.c"
		}
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (_search_path_list);
#line 716 "IconManager.c"
	}
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = pixbuf;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 722 "IconManager.c"
}


GtkImage* icon_manager_lookup_image (const gchar* icon_name, gint icon_size, gboolean symbolic, gboolean use_hardcoded) {
	GtkImage* result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkImage* image = NULL;
	GtkImage* _tmp3_;
	GdkPixbuf* pix = NULL;
	const gchar* _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkImage* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	cairo_surface_t* surf = NULL;
	GdkPixbuf* _tmp20_;
	GtkImage* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	cairo_surface_t* _tmp24_;
	GtkImage* _tmp25_;
	cairo_surface_t* _tmp26_;
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = icon_name;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = strlen (_tmp0_);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _tmp1_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp2_ == 0) {
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = NULL;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 765 "IconManager.c"
	}
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp3_ = (GtkImage*) gtk_image_new ();
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_object_ref_sink (_tmp3_);
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	image = _tmp3_;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp4_ = icon_name;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp5_ = icon_size;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp6_ = symbolic;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp7_ = use_hardcoded;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp8_ = image;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp9_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp8_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp10_ = _tmp9_;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp11_ = icon_manager_lookup (_tmp4_, _tmp5_, _tmp6_, _tmp7_, _tmp10_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	pix = _tmp11_;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp12_ = pix;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp12_ == NULL) {
#line 795 "IconManager.c"
		gint _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		GtkImage* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		GdkPixbuf* _tmp19_;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp13_ = icon_size;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp14_ = symbolic;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp15_ = use_hardcoded;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp16_ = image;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp17_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp16_);
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp18_ = _tmp17_;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp19_ = icon_manager_lookup (ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING, _tmp13_, _tmp14_, _tmp15_, _tmp18_);
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (pix);
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		pix = _tmp19_;
#line 821 "IconManager.c"
	}
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp20_ = pix;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp21_ = image;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp22_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp21_);
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp23_ = _tmp22_;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp24_ = gdk_cairo_surface_create_from_pixbuf (_tmp20_, _tmp23_, NULL);
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	surf = _tmp24_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp25_ = image;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp26_ = surf;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gtk_image_set_from_surface (_tmp25_, _tmp26_);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = image;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_cairo_surface_destroy0 (surf);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_object_unref0 (pix);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 849 "IconManager.c"
}


cairo_surface_t* icon_manager_lookup_surface (const gchar* icon_name, gint icon_size, gint scale, gboolean symbolic, gboolean use_hardcoded) {
	cairo_surface_t* result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* pix = NULL;
	const gchar* _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gint _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp15_;
	gint _tmp16_;
	cairo_surface_t* _tmp17_;
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = icon_name;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = strlen (_tmp0_);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _tmp1_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp2_ == 0) {
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = NULL;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 883 "IconManager.c"
	}
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp3_ = icon_name;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp4_ = icon_size;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp5_ = symbolic;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp6_ = use_hardcoded;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp7_ = scale;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp8_ = icon_manager_lookup (_tmp3_, _tmp4_, _tmp5_, _tmp6_, _tmp7_);
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	pix = _tmp8_;
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp9_ = pix;
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp9_ == NULL) {
#line 903 "IconManager.c"
		gint _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		gint _tmp13_;
		GdkPixbuf* _tmp14_;
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp10_ = icon_size;
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp11_ = symbolic;
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp12_ = use_hardcoded;
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp13_ = scale;
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp14_ = icon_manager_lookup (ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING, _tmp10_, _tmp11_, _tmp12_, _tmp13_);
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (pix);
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		pix = _tmp14_;
#line 923 "IconManager.c"
	}
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp15_ = pix;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp16_ = scale;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp17_ = gdk_cairo_surface_create_from_pixbuf (_tmp15_, _tmp16_, NULL);
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = _tmp17_;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_object_unref0 (pix);
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 937 "IconManager.c"
}


GdkPixbuf* icon_manager_lookup_gicon (GIcon* gicon, gint icon_size) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GIcon* _tmp0_;
	GError * _inner_error_ = NULL;
#line 167 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	pixbuf = NULL;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = gicon;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp0_ == NULL) {
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = NULL;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 958 "IconManager.c"
	}
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp1_;
		GIcon* _tmp2_;
		gint _tmp3_;
		GtkIconInfo* _tmp4_;
		GtkIconInfo* _tmp5_;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp1_ = icon_manager_theme;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp2_ = gicon;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp3_ = icon_size;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp4_ = gtk_icon_theme_lookup_by_gicon (_tmp1_, _tmp2_, _tmp3_, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		icon_info = _tmp4_;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp5_ = icon_info;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		if (_tmp5_ != NULL) {
#line 981 "IconManager.c"
			GdkPixbuf* _tmp6_ = NULL;
			GtkIconInfo* _tmp7_;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp7_ = icon_info;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp8_ = gtk_icon_info_load_icon (_tmp7_, &_inner_error_);
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp6_ = _tmp8_;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				_gtk_icon_info_free0 (icon_info);
#line 996 "IconManager.c"
				goto __catch56_g_error;
			}
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp9_ = _tmp6_;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp6_ = NULL;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			pixbuf = _tmp9_;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (_tmp6_);
#line 1009 "IconManager.c"
		}
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_gtk_icon_info_free0 (icon_info);
#line 1013 "IconManager.c"
	}
	goto __finally56;
	__catch56_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		e = _inner_error_;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_inner_error_ = NULL;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp10_ = e;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp11_ = _tmp10_->message;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp11_);
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_error_free0 (e);
#line 1033 "IconManager.c"
	}
	__finally56:
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		g_clear_error (&_inner_error_);
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return NULL;
#line 1046 "IconManager.c"
	}
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = pixbuf;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 1052 "IconManager.c"
}


GtkImage* icon_manager_lookup_animation (const gchar* gif_name) {
	GtkImage* result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (gif_name != NULL, NULL);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = gif_name;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = strlen (_tmp0_);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _tmp1_;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp2_ == 0) {
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = NULL;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 1075 "IconManager.c"
	}
	{
		GeeArrayList* _search_path_list = NULL;
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		gint _search_path_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _search_path_index = 0;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp3_ = icon_manager_search_paths;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_search_path_list = _tmp4_;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp5_ = _search_path_list;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp7_ = _tmp6_;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_search_path_size = _tmp7_;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_search_path_index = -1;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		while (TRUE) {
#line 1104 "IconManager.c"
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gchar* search_path = NULL;
			GeeArrayList* _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			gchar* _tmp14_;
			gchar** _tmp15_;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp8_ = _search_path_index;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_search_path_index = _tmp8_ + 1;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp9_ = _search_path_index;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp10_ = _search_path_size;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				break;
#line 1126 "IconManager.c"
			}
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp11_ = _search_path_list;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp12_ = _search_path_index;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			search_path = (gchar*) _tmp13_;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp14_ = g_strdup (".gif");
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp15_ = g_new0 (gchar*, 1 + 1);
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp15_[0] = _tmp14_;
#line 1142 "IconManager.c"
			{
				gchar** ext_collection = NULL;
				gint ext_collection_length1 = 0;
				gint _ext_collection_size_ = 0;
				gint ext_it = 0;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				ext_collection = _tmp15_;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				ext_collection_length1 = 1;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				for (ext_it = 0; ext_it < 1; ext_it = ext_it + 1) {
#line 1154 "IconManager.c"
					gchar* _tmp16_;
					gchar* ext = NULL;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
					_tmp16_ = g_strdup (ext_collection[ext_it]);
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
					ext = _tmp16_;
#line 1161 "IconManager.c"
					{
						gchar* img_file = NULL;
						const gchar* _tmp17_;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						const gchar* _tmp24_;
						gboolean _tmp25_;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp17_ = search_path;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp18_ = gif_name;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp19_ = ext;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp20_ = g_strconcat (_tmp18_, _tmp19_, NULL);
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp21_ = _tmp20_;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp22_ = tee_jee_file_system_path_combine (_tmp17_, _tmp21_);
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp23_ = _tmp22_;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_g_free0 (_tmp21_);
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						img_file = _tmp23_;
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp24_ = img_file;
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_tmp25_ = tee_jee_file_system_file_exists (_tmp24_);
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						if (_tmp25_) {
#line 1197 "IconManager.c"
							const gchar* _tmp26_;
							GtkImage* _tmp27_;
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_tmp26_ = img_file;
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_tmp27_ = (GtkImage*) gtk_image_new_from_file (_tmp26_);
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							g_object_ref_sink (_tmp27_);
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							result = _tmp27_;
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_g_free0 (img_file);
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_g_free0 (ext);
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_g_free0 (search_path);
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							_g_object_unref0 (_search_path_list);
#line 196 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
							return result;
#line 1220 "IconManager.c"
						}
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_g_free0 (img_file);
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
						_g_free0 (ext);
#line 1226 "IconManager.c"
					}
				}
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1231 "IconManager.c"
			}
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_free0 (search_path);
#line 1235 "IconManager.c"
		}
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (_search_path_list);
#line 1239 "IconManager.c"
	}
#line 201 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = NULL;
#line 201 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 1245 "IconManager.c"
}


GdkPixbuf* icon_manager_add_emblem (GdkPixbuf* pixbuf, const gchar* icon_name, gint emblem_size, gboolean emblem_symbolic, GtkCornerType corner_type) {
	GdkPixbuf* result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* emblem = NULL;
	GdkRGBA SMALL_EMBLEM_COLOR = {0};
	gint EMBLEM_PADDING = 0;
	GdkPixbuf* _tmp25_;
	gint offset_x = 0;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	GtkCornerType _tmp30_;
	gint offset_y = 0;
	gint _tmp39_;
	gboolean _tmp40_ = FALSE;
	GtkCornerType _tmp41_;
	GdkPixbuf* emblemed = NULL;
	GdkPixbuf* _tmp50_;
	GdkPixbuf* _tmp51_;
	GdkPixbuf* _tmp52_;
	GdkPixbuf* _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	GError * _inner_error_ = NULL;
#line 204 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 204 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = icon_name;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = strlen (_tmp0_);
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _tmp1_;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp2_ == 0) {
#line 1290 "IconManager.c"
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp3_ = pixbuf;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = _tmp4_;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 1301 "IconManager.c"
	}
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	emblem = NULL;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	memset (&SMALL_EMBLEM_COLOR, 0, sizeof (GdkRGBA));
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gdk_rgba_parse (&SMALL_EMBLEM_COLOR, "#000000");
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	SMALL_EMBLEM_COLOR.alpha = 1.0;
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	EMBLEM_PADDING = 1;
#line 1313 "IconManager.c"
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		GtkIconInfo* _tmp8_;
		gboolean _tmp9_;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp5_ = icon_manager_theme;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp6_ = icon_name;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp7_ = emblem_size;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp8_ = gtk_icon_theme_lookup_icon (_tmp5_, _tmp6_, _tmp7_, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		icon_info = _tmp8_;
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp9_ = emblem_symbolic;
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		if (_tmp9_) {
#line 1335 "IconManager.c"
			GdkPixbuf* _tmp10_ = NULL;
			GtkIconInfo* _tmp11_;
			GdkRGBA _tmp12_;
			GdkPixbuf* _tmp13_;
			GdkPixbuf* _tmp14_;
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp11_ = icon_info;
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp12_ = SMALL_EMBLEM_COLOR;
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp13_ = gtk_icon_info_load_symbolic (_tmp11_, &_tmp12_, NULL, NULL, NULL, NULL, &_inner_error_);
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp10_ = _tmp13_;
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				_gtk_icon_info_free0 (icon_info);
#line 1353 "IconManager.c"
				goto __catch57_g_error;
			}
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp14_ = _tmp10_;
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp10_ = NULL;
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (emblem);
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			emblem = _tmp14_;
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (_tmp10_);
#line 1366 "IconManager.c"
		} else {
			GdkPixbuf* _tmp15_ = NULL;
			GtkIconInfo* _tmp16_;
			GdkPixbuf* _tmp17_;
			GdkPixbuf* _tmp18_;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp16_ = icon_info;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp17_ = gtk_icon_info_load_icon (_tmp16_, &_inner_error_);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp15_ = _tmp17_;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				_gtk_icon_info_free0 (icon_info);
#line 1382 "IconManager.c"
				goto __catch57_g_error;
			}
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp18_ = _tmp15_;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp15_ = NULL;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (emblem);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			emblem = _tmp18_;
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (_tmp15_);
#line 1395 "IconManager.c"
		}
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_gtk_icon_info_free0 (icon_info);
#line 1399 "IconManager.c"
	}
	goto __finally57;
	__catch57_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		e = _inner_error_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_inner_error_ = NULL;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp19_ = e;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp20_ = _tmp19_->message;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp21_ = g_strdup_printf ("get_icon_emblemed(): %s", _tmp20_);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp22_ = _tmp21_;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_free0 (_tmp22_);
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp23_ = pixbuf;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = _tmp24_;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_error_free0 (e);
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 1439 "IconManager.c"
	}
	__finally57:
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		g_clear_error (&_inner_error_);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return NULL;
#line 1452 "IconManager.c"
	}
#line 230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp25_ = emblem;
#line 230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp25_ == NULL) {
#line 1458 "IconManager.c"
		GdkPixbuf* _tmp26_;
		GdkPixbuf* _tmp27_;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp26_ = pixbuf;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp27_ = _g_object_ref0 (_tmp26_);
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		result = _tmp27_;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		return result;
#line 1471 "IconManager.c"
	}
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp28_ = EMBLEM_PADDING;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	offset_x = _tmp28_;
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp30_ = corner_type;
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp30_ == GTK_CORNER_BOTTOM_RIGHT) {
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp29_ = TRUE;
#line 1483 "IconManager.c"
	} else {
		GtkCornerType _tmp31_;
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp31_ = corner_type;
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp29_ = _tmp31_ == GTK_CORNER_TOP_RIGHT;
#line 1490 "IconManager.c"
	}
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp29_) {
#line 1494 "IconManager.c"
		GdkPixbuf* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		GdkPixbuf* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp32_ = pixbuf;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp33_ = gdk_pixbuf_get_width (_tmp32_);
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp34_ = _tmp33_;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp35_ = emblem;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp36_ = gdk_pixbuf_get_width (_tmp35_);
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp37_ = _tmp36_;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp38_ = EMBLEM_PADDING;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		offset_x = (_tmp34_ - _tmp37_) - _tmp38_;
#line 1518 "IconManager.c"
	}
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp39_ = EMBLEM_PADDING;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	offset_y = _tmp39_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp41_ = corner_type;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp41_ == GTK_CORNER_BOTTOM_LEFT) {
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp40_ = TRUE;
#line 1530 "IconManager.c"
	} else {
		GtkCornerType _tmp42_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp42_ = corner_type;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp40_ = _tmp42_ == GTK_CORNER_BOTTOM_RIGHT;
#line 1537 "IconManager.c"
	}
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp40_) {
#line 1541 "IconManager.c"
		GdkPixbuf* _tmp43_;
		gint _tmp44_;
		gint _tmp45_;
		GdkPixbuf* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp43_ = pixbuf;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp44_ = gdk_pixbuf_get_height (_tmp43_);
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp45_ = _tmp44_;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp46_ = emblem;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp47_ = gdk_pixbuf_get_height (_tmp46_);
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp48_ = _tmp47_;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp49_ = EMBLEM_PADDING;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		offset_y = (_tmp45_ - _tmp48_) - _tmp49_;
#line 1565 "IconManager.c"
	}
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp50_ = pixbuf;
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp51_ = gdk_pixbuf_copy (_tmp50_);
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	emblemed = _tmp51_;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp52_ = emblem;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp53_ = emblemed;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp54_ = offset_x;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp55_ = offset_y;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp56_ = emblem_size;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp57_ = emblem_size;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp58_ = offset_x;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp59_ = offset_y;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gdk_pixbuf_composite (_tmp52_, _tmp53_, _tmp54_, _tmp55_, _tmp56_, _tmp57_, (gdouble) _tmp58_, (gdouble) _tmp59_, 1.0, 1.0, GDK_INTERP_BILINEAR, 255);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = emblemed;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_object_unref0 (emblem);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 1597 "IconManager.c"
}


GdkPixbuf* icon_manager_add_overlay (GdkPixbuf* pixbuf_base, GdkPixbuf* pixbuf_overlay) {
	GdkPixbuf* result = NULL;
	gint offset_x = 0;
	GdkPixbuf* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint offset_y = 0;
	GdkPixbuf* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkPixbuf* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GdkPixbuf* emblemed = NULL;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* _tmp14_;
	GdkPixbuf* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GdkPixbuf* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_base != NULL, NULL);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_overlay != NULL, NULL);
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = pixbuf_base;
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = gdk_pixbuf_get_width (_tmp0_);
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = _tmp1_;
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp3_ = pixbuf_overlay;
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp4_ = gdk_pixbuf_get_width (_tmp3_);
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp5_ = _tmp4_;
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	offset_x = (_tmp2_ - _tmp5_) / 2;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp6_ = pixbuf_base;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp7_ = gdk_pixbuf_get_height (_tmp6_);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp8_ = _tmp7_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp9_ = pixbuf_overlay;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp10_ = gdk_pixbuf_get_height (_tmp9_);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp11_ = _tmp10_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	offset_y = (_tmp8_ - _tmp11_) / 2;
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp12_ = pixbuf_base;
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp13_ = gdk_pixbuf_copy (_tmp12_);
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	emblemed = _tmp13_;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp14_ = pixbuf_overlay;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp15_ = pixbuf_overlay;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp16_ = gdk_pixbuf_get_width (_tmp15_);
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp17_ = _tmp16_;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp18_ = pixbuf_overlay;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp19_ = gdk_pixbuf_get_height (_tmp18_);
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp20_ = _tmp19_;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gdk_pixbuf_composite (_tmp14_, emblemed, offset_x, offset_y, _tmp17_, _tmp20_, (gdouble) offset_x, (gdouble) offset_y, 1.0, 1.0, GDK_INTERP_BILINEAR, 255);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = emblemed;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 1685 "IconManager.c"
}


GdkPixbuf* icon_manager_resize_icon (GdkPixbuf* pixbuf_image, gint icon_size) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf_empty = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* pixbuf_resized = NULL;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_image != NULL, NULL);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = icon_size;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = icon_size;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, _tmp0_, _tmp1_);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	pixbuf_empty = _tmp2_;
#line 280 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gdk_pixbuf_fill (pixbuf_empty, (guint32) 0x00000000);
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp3_ = pixbuf_image;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp4_ = icon_manager_add_overlay (pixbuf_empty, _tmp3_);
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	pixbuf_resized = _tmp4_;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = pixbuf_resized;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_object_unref0 (pixbuf_empty);
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 1722 "IconManager.c"
}


GdkPixbuf* icon_manager_add_transparency (GdkPixbuf* pixbuf, gint opacity) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* trans = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	gint width = 0;
	GdkPixbuf* _tmp2_;
	gint _tmp3_;
	gint height = 0;
	GdkPixbuf* _tmp4_;
	gint _tmp5_;
	GdkPixbuf* _tmp6_;
	gint _tmp7_;
#line 293 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = pixbuf;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp1_ = gdk_pixbuf_copy (_tmp0_);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	trans = _tmp1_;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gdk_pixbuf_fill (trans, (guint32) 0xFFFFFF00LL);
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp2_ = pixbuf;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp3_ = gdk_pixbuf_get_width (_tmp2_);
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	width = _tmp3_;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp4_ = pixbuf;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp5_ = gdk_pixbuf_get_height (_tmp4_);
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	height = _tmp5_;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp6_ = pixbuf;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp7_ = opacity;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gdk_pixbuf_composite (_tmp6_, trans, 0, 0, width, height, (gdouble) 0, (gdouble) 0, 1.0, 1.0, GDK_INTERP_BILINEAR, _tmp7_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = trans;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 1771 "IconManager.c"
}


GdkPixbuf* icon_manager_load_pixbuf_from_file (const gchar* file_path, gint icon_size) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	gint width = 0;
	gint height = 0;
	const gchar* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint _tmp5_;
	GError * _inner_error_ = NULL;
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	pixbuf = NULL;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = file_path;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	gdk_pixbuf_get_file_info (_tmp0_, &_tmp1_, &_tmp2_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	width = _tmp1_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	height = _tmp2_;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp4_ = width;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp5_ = icon_size;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp4_ <= _tmp5_) {
#line 1805 "IconManager.c"
		gint _tmp6_;
		gint _tmp7_;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp6_ = height;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp7_ = icon_size;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp3_ = _tmp6_ <= _tmp7_;
#line 1814 "IconManager.c"
	} else {
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		_tmp3_ = FALSE;
#line 1818 "IconManager.c"
	}
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	if (_tmp3_) {
#line 1822 "IconManager.c"
		{
			GdkPixbuf* _tmp8_ = NULL;
			const gchar* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			gint _tmp13_;
			GdkPixbuf* _tmp14_;
			GdkPixbuf* _tmp15_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp9_ = file_path;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp10_ = gdk_pixbuf_new_from_file (_tmp9_, &_inner_error_);
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp8_ = _tmp10_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1840 "IconManager.c"
				goto __catch58_g_error;
			}
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp11_ = _tmp8_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp8_ = NULL;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			pixbuf = _tmp11_;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp12_ = pixbuf;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp13_ = icon_size;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp14_ = icon_manager_resize_icon (_tmp12_, _tmp13_);
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			pixbuf = _tmp14_;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp15_ = pixbuf;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (_tmp15_ != NULL) {
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				result = pixbuf;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				_g_object_unref0 (_tmp8_);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				return result;
#line 1871 "IconManager.c"
			}
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (_tmp8_);
#line 1875 "IconManager.c"
		}
		goto __finally58;
		__catch58_g_error:
		{
			GError* e = NULL;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			e = _inner_error_;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_inner_error_ = NULL;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_error_free0 (e);
#line 1887 "IconManager.c"
		}
		__finally58:
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			g_clear_error (&_inner_error_);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			return NULL;
#line 1900 "IconManager.c"
		}
	} else {
		{
			GdkPixbuf* _tmp16_ = NULL;
			const gchar* _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			GdkPixbuf* _tmp20_;
			GdkPixbuf* _tmp21_;
			GdkPixbuf* _tmp22_;
			gint _tmp23_;
			GdkPixbuf* _tmp24_;
			GdkPixbuf* _tmp25_;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp17_ = file_path;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp18_ = icon_size;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp19_ = icon_size;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp20_ = gdk_pixbuf_new_from_file_at_scale (_tmp17_, _tmp18_, _tmp19_, TRUE, &_inner_error_);
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp16_ = _tmp20_;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1926 "IconManager.c"
				goto __catch59_g_error;
			}
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp21_ = _tmp16_;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp16_ = NULL;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			pixbuf = _tmp21_;
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp22_ = pixbuf;
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp23_ = icon_size;
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp24_ = icon_manager_resize_icon (_tmp22_, _tmp23_);
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			pixbuf = _tmp24_;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_tmp25_ = pixbuf;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			if (_tmp25_ != NULL) {
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				result = pixbuf;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				_g_object_unref0 (_tmp16_);
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
				return result;
#line 1957 "IconManager.c"
			}
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (_tmp16_);
#line 1961 "IconManager.c"
		}
		goto __finally59;
		__catch59_g_error:
		{
			GError* e = NULL;
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			e = _inner_error_;
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_inner_error_ = NULL;
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_error_free0 (e);
#line 1973 "IconManager.c"
		}
		__finally59:
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			g_clear_error (&_inner_error_);
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
			return NULL;
#line 1986 "IconManager.c"
		}
	}
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	result = NULL;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_g_object_unref0 (pixbuf);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return result;
#line 1995 "IconManager.c"
}


IconManager* icon_manager_construct (GType object_type) {
	IconManager * self = NULL;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	self = (IconManager*) g_object_new (object_type, NULL);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return self;
#line 2005 "IconManager.c"
}


IconManager* icon_manager_new (void) {
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	return icon_manager_construct (TYPE_ICON_MANAGER);
#line 2012 "IconManager.c"
}


static void icon_manager_class_init (IconManagerClass * klass) {
	GeeArrayList* _tmp0_;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	icon_manager_parent_class = g_type_class_peek_parent (klass);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_manager_finalize;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	icon_manager_search_paths = _tmp0_;
#line 2026 "IconManager.c"
}


static void icon_manager_instance_init (IconManager * self) {
}


static void icon_manager_finalize (GObject * obj) {
	IconManager * self;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_MANAGER, IconManager);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/IconManager.vala"
	G_OBJECT_CLASS (icon_manager_parent_class)->finalize (obj);
#line 2040 "IconManager.c"
}


GType icon_manager_get_type (void) {
	static volatile gsize icon_manager_type_id__volatile = 0;
	if (g_once_init_enter (&icon_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IconManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconManager), 0, (GInstanceInitFunc) icon_manager_instance_init, NULL };
		GType icon_manager_type_id;
		icon_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "IconManager", &g_define_type_info, 0);
		g_once_init_leave (&icon_manager_type_id__volatile, icon_manager_type_id);
	}
	return icon_manager_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



