/* TerminalWindow.c generated by valac 0.38.10, the Vala compiler
 * generated from TerminalWindow.vala, do not modify */

/*
 * TerminalWindow.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <vte/vte.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_TERMINAL_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TERMINAL_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TERMINAL_WINDOW, TerminalWindowClass))
#define IS_TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TERMINAL_WINDOW))
#define IS_TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TERMINAL_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TERMINAL_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;
typedef struct _TerminalWindowPrivate TerminalWindowPrivate;
enum  {
	TERMINAL_WINDOW_0_PROPERTY,
	TERMINAL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* terminal_window_properties[TERMINAL_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TerminalWindow {
	GtkWindow parent_instance;
	TerminalWindowPrivate * priv;
	gboolean is_running;
};

struct _TerminalWindowClass {
	GtkWindowClass parent_class;
};

struct _TerminalWindowPrivate {
	GtkBox* vbox_main;
	VteTerminal* term;
	gint def_width;
	gint def_height;
	GPid child_pid;
	GtkWindow* parent_win;
};


static gpointer terminal_window_parent_class = NULL;
extern gchar* tee_jee_process_helper_TEMP_DIR;

GType terminal_window_get_type (void) G_GNUC_CONST;
#define TERMINAL_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TERMINAL_WINDOW, TerminalWindowPrivate))
TerminalWindow* terminal_window_new_with_parent (GtkWindow* parent);
TerminalWindow* terminal_window_construct_with_parent (GType object_type, GtkWindow* parent);
static gboolean __lambda15_ (TerminalWindow* self);
static gboolean ___lambda15__gtk_widget_delete_event (GtkWidget* _sender, GdkEventAny* event, gpointer self);
void terminal_window_init_window (TerminalWindow* self);
GdkPixbuf* icon_manager_lookup (const gchar* icon_name, gint icon_size, gboolean symbolic, gboolean use_hardcoded, gint scale);
void terminal_window_start_shell (TerminalWindow* self);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
void terminal_window_execute_command (TerminalWindow* self, const gchar* command);
void terminal_window_execute_script (TerminalWindow* self, const gchar* script_path, gboolean wait);
void terminal_window_script_exit (TerminalWindow* self, gint status);
static void _terminal_window_script_exit_vte_terminal_child_exited (VteTerminal* _sender, gint status, gpointer self);
void tee_jee_system_sleep (gint milliseconds);
void tee_jee_gtk_helper_gtk_do_events (void);
TerminalWindow* terminal_window_new (void);
TerminalWindow* terminal_window_construct (GType object_type);
static void terminal_window_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 107 "TerminalWindow.c"
}


static gboolean __lambda15_ (TerminalWindow* self) {
	gboolean result = FALSE;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	result = TRUE;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	return result;
#line 117 "TerminalWindow.c"
}


static gboolean ___lambda15__gtk_widget_delete_event (GtkWidget* _sender, GdkEventAny* event, gpointer self) {
	gboolean result;
	result = __lambda15_ ((TerminalWindow*) self);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	return result;
#line 126 "TerminalWindow.c"
}


TerminalWindow* terminal_window_construct_with_parent (GType object_type, GtkWindow* parent) {
	TerminalWindow * self = NULL;
	GtkWindow* _tmp0_;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self = (TerminalWindow*) g_object_new (object_type, NULL);
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = parent;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	if (_tmp0_ != NULL) {
#line 139 "TerminalWindow.c"
		GtkWindow* _tmp1_;
		GtkWindow* _tmp2_;
		GtkWindow* _tmp3_;
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp1_ = parent;
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		gtk_window_set_transient_for ((GtkWindow*) self, _tmp1_);
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp2_ = parent;
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_g_object_unref0 (self->priv->parent_win);
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		self->priv->parent_win = _tmp3_;
#line 155 "TerminalWindow.c"
	}
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_window_fullscreen ((GtkWindow*) self);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) ___lambda15__gtk_widget_delete_event, self, 0);
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	terminal_window_init_window (self);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	return self;
#line 167 "TerminalWindow.c"
}


TerminalWindow* terminal_window_new_with_parent (GtkWindow* parent) {
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	return terminal_window_construct_with_parent (TYPE_TERMINAL_WINDOW, parent);
#line 174 "TerminalWindow.c"
}


void terminal_window_init_window (TerminalWindow* self) {
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkBox* _tmp6_;
	VteTerminal* _tmp7_;
	VteTerminal* _tmp8_;
	GtkBox* _tmp9_;
	VteTerminal* _tmp10_;
	VteTerminal* _tmp11_;
	VteTerminal* _tmp12_;
	VteTerminal* _tmp13_;
	VteTerminal* _tmp14_;
	VteTerminal* _tmp15_;
	VteTerminal* _tmp16_;
	VteTerminal* _tmp17_;
	GdkRGBA color = {0};
	VteTerminal* _tmp18_;
	GdkRGBA _tmp19_;
	VteTerminal* _tmp20_;
	GdkRGBA _tmp21_;
	VteTerminal* _tmp22_;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, "");
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = icon_manager_lookup ("timeshift", 16, FALSE, FALSE, 1);
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = _tmp0_;
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_icon ((GtkWindow*) self, _tmp1_);
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->vbox_main);
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->priv->vbox_main = _tmp2_;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp3_ = self->priv->vbox_main;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp4_ = self->priv->def_width;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp5_ = self->priv->def_height;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp3_, _tmp4_, _tmp5_);
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp6_ = self->priv->vbox_main;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp6_);
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp7_ = (VteTerminal*) vte_terminal_new ();
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->term);
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->priv->term = _tmp7_;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp8_ = self->priv->term;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_object_set ((GtkWidget*) _tmp8_, "expand", TRUE, NULL);
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp9_ = self->priv->vbox_main;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp10_ = self->priv->term;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp11_ = self->priv->term;
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_input_enabled (_tmp11_, TRUE);
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp12_ = self->priv->term;
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_object_set (_tmp12_, "backspace-binding", VTE_ERASE_AUTO, NULL);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp13_ = self->priv->term;
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_cursor_blink_mode (_tmp13_, VTE_CURSOR_BLINK_SYSTEM);
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp14_ = self->priv->term;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_cursor_shape (_tmp14_, VTE_CURSOR_SHAPE_UNDERLINE);
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp15_ = self->priv->term;
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_rewrap_on_resize (_tmp15_, TRUE);
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp16_ = self->priv->term;
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_object_set (_tmp16_, "scroll-on-keystroke", TRUE, NULL);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp17_ = self->priv->term;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_object_set (_tmp17_, "scroll-on-output", TRUE, NULL);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gdk_rgba_parse (&color, "#FFFFFF");
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp18_ = self->priv->term;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp19_ = color;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_color_foreground (_tmp18_, &_tmp19_);
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gdk_rgba_parse (&color, "#404040");
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp20_ = self->priv->term;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp21_ = color;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_color_background (_tmp20_, &_tmp21_);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp22_ = self->priv->term;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp22_);
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 309 "TerminalWindow.c"
}


void terminal_window_start_shell (TerminalWindow* self) {
	gchar** argv = NULL;
	gchar** _tmp0_;
	gint argv_length1;
	gint _argv_size_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** env = NULL;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint env_length1;
	gint _env_size_;
	GError * _inner_error_ = NULL;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = g_new0 (gchar*, 1 + 1);
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv = _tmp0_;
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv_length1 = 1;
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_argv_size_ = argv_length1;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = g_strdup ("/bin/sh");
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_free0 (argv[0]);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv[0] = _tmp1_;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp2_ = argv[0];
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp4_ = _tmp3_ = g_get_environ ();
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	env = _tmp4_;
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	env_length1 = _vala_array_length (_tmp3_);
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_env_size_ = env_length1;
#line 352 "TerminalWindow.c"
	{
		VteTerminal* _tmp5_;
		const gchar* _tmp6_;
		GPid _tmp7_ = 0;
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		self->is_running = TRUE;
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp5_ = self->priv->term;
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp6_ = tee_jee_process_helper_TEMP_DIR;
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		vte_terminal_spawn_sync (_tmp5_, VTE_PTY_DEFAULT, _tmp6_, argv, env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp7_, NULL, &_inner_error_);
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		self->priv->child_pid = _tmp7_;
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 369 "TerminalWindow.c"
			goto __catch102_g_error;
		}
	}
	goto __finally102;
	__catch102_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		e = _inner_error_;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_inner_error_ = NULL;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp8_ = e;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp9_ = _tmp8_->message;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		tee_jee_logging_log_error (_tmp9_, FALSE, FALSE);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_g_error_free0 (e);
#line 391 "TerminalWindow.c"
	}
	__finally102:
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		g_clear_error (&_inner_error_);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		return;
#line 406 "TerminalWindow.c"
	}
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 412 "TerminalWindow.c"
}


void terminal_window_execute_command (TerminalWindow* self, const gchar* command) {
	VteTerminal* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (command != NULL);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = self->priv->term;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = command;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp2_ = g_strdup_printf ("%s\n", _tmp1_);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp3_ = _tmp2_;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	vte_terminal_feed_child (_tmp0_, _tmp3_, (gssize) -1);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_free0 (_tmp3_);
#line 437 "TerminalWindow.c"
}


static void _terminal_window_script_exit_vte_terminal_child_exited (VteTerminal* _sender, gint status, gpointer self) {
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	terminal_window_script_exit ((TerminalWindow*) self, status);
#line 444 "TerminalWindow.c"
}


void terminal_window_execute_script (TerminalWindow* self, const gchar* script_path, gboolean wait) {
	gchar** argv = NULL;
	gchar** _tmp0_;
	gint argv_length1;
	gint _argv_size_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** env = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint env_length1;
	gint _env_size_;
	GError * _inner_error_ = NULL;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (script_path != NULL);
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = g_new0 (gchar*, 1 + 1);
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv = _tmp0_;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv_length1 = 1;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_argv_size_ = argv_length1;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = script_path;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_free0 (argv[0]);
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv[0] = _tmp2_;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp3_ = argv[0];
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp5_ = _tmp4_ = g_get_environ ();
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	env = _tmp5_;
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	env_length1 = _vala_array_length (_tmp4_);
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_env_size_ = env_length1;
#line 492 "TerminalWindow.c"
	{
		VteTerminal* _tmp6_;
		const gchar* _tmp7_;
		GPid _tmp8_ = 0;
		VteTerminal* _tmp9_;
		GPid _tmp10_;
		VteTerminal* _tmp11_;
		gboolean _tmp12_;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		self->is_running = TRUE;
#line 184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp6_ = self->priv->term;
#line 184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp7_ = tee_jee_process_helper_TEMP_DIR;
#line 184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		vte_terminal_spawn_sync (_tmp6_, VTE_PTY_DEFAULT, _tmp7_, argv, env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp8_, NULL, &_inner_error_);
#line 184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		self->priv->child_pid = _tmp8_;
#line 184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 513 "TerminalWindow.c"
			goto __catch103_g_error;
		}
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp9_ = self->priv->term;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp10_ = self->priv->child_pid;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		vte_terminal_watch_child (_tmp9_, _tmp10_);
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp11_ = self->priv->term;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		g_signal_connect_object (_tmp11_, "child-exited", (GCallback) _terminal_window_script_exit_vte_terminal_child_exited, self, 0);
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp12_ = wait;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		if (_tmp12_) {
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
			while (TRUE) {
#line 532 "TerminalWindow.c"
				gboolean _tmp13_;
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
				_tmp13_ = self->is_running;
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
				if (!_tmp13_) {
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
					break;
#line 540 "TerminalWindow.c"
				}
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
				tee_jee_system_sleep (200);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
				tee_jee_gtk_helper_gtk_do_events ();
#line 546 "TerminalWindow.c"
			}
		}
	}
	goto __finally103;
	__catch103_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		e = _inner_error_;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_inner_error_ = NULL;
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp14_ = e;
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp15_ = _tmp14_->message;
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_g_error_free0 (e);
#line 568 "TerminalWindow.c"
	}
	__finally103:
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		g_clear_error (&_inner_error_);
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		return;
#line 583 "TerminalWindow.c"
	}
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 589 "TerminalWindow.c"
}


void terminal_window_script_exit (TerminalWindow* self, gint status) {
	GtkContainer* _tmp0_;
	GtkContainer* _tmp1_;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->is_running = FALSE;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = _tmp0_;
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	if (_tmp1_ != NULL) {
#line 608 "TerminalWindow.c"
		GtkWindow* _tmp2_;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		_tmp2_ = self->priv->parent_win;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp2_);
#line 614 "TerminalWindow.c"
	}
}


TerminalWindow* terminal_window_construct (GType object_type) {
	TerminalWindow * self = NULL;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self = (TerminalWindow*) g_object_new (object_type, NULL);
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	return self;
#line 625 "TerminalWindow.c"
}


TerminalWindow* terminal_window_new (void) {
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	return terminal_window_construct (TYPE_TERMINAL_WINDOW);
#line 632 "TerminalWindow.c"
}


static void terminal_window_class_init (TerminalWindowClass * klass) {
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	terminal_window_parent_class = g_type_class_peek_parent (klass);
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	g_type_class_add_private (klass, sizeof (TerminalWindowPrivate));
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_window_finalize;
#line 643 "TerminalWindow.c"
}


static void terminal_window_instance_init (TerminalWindow * self) {
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->priv = TERMINAL_WINDOW_GET_PRIVATE (self);
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->priv->def_width = 800;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->priv->def_height = 600;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->priv->parent_win = NULL;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self->is_running = FALSE;
#line 658 "TerminalWindow.c"
}


static void terminal_window_finalize (GObject * obj) {
	TerminalWindow * self;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TERMINAL_WINDOW, TerminalWindow);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->vbox_main);
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->term);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->parent_win);
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Gtk/TerminalWindow.vala"
	G_OBJECT_CLASS (terminal_window_parent_class)->finalize (obj);
#line 674 "TerminalWindow.c"
}


GType terminal_window_get_type (void) {
	static volatile gsize terminal_window_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TerminalWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalWindow), 0, (GInstanceInitFunc) terminal_window_instance_init, NULL };
		GType terminal_window_type_id;
		terminal_window_type_id = g_type_register_static (gtk_window_get_type (), "TerminalWindow", &g_define_type_info, 0);
		g_once_init_leave (&terminal_window_type_id__volatile, terminal_window_type_id);
	}
	return terminal_window_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



