/* Bash.c generated by valac 0.38.10, the Vala compiler
 * generated from Bash.vala, do not modify */

/*
 * Bash.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <stdio.h>


#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;

#define TYPE_APP_STATUS (app_status_get_type ())

#define TYPE_BASH (bash_get_type ())
#define BASH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASH, Bash))
#define BASH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASH, BashClass))
#define IS_BASH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASH))
#define IS_BASH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASH))
#define BASH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASH, BashClass))

typedef struct _Bash Bash;
typedef struct _BashClass BashClass;
typedef struct _BashPrivate BashPrivate;
enum  {
	BASH_0_PROPERTY,
	BASH_NUM_PROPERTIES
};
static GParamSpec* bash_properties[BASH_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	gchar* status_line;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _Bash {
	AsyncTask parent_instance;
	BashPrivate * priv;
	GPid bash_pid;
	gint status_code;
};

struct _BashClass {
	AsyncTaskClass parent_class;
};


static gpointer bash_parent_class = NULL;
static GeeHashMap* bash_regex_list;
static GeeHashMap* bash_regex_list = NULL;

GType async_task_get_type (void) G_GNUC_CONST;
GType app_status_get_type (void) G_GNUC_CONST;
GType bash_get_type (void) G_GNUC_CONST;
Bash* bash_new (void);
Bash* bash_construct (GType object_type);
AsyncTask* async_task_construct (GType object_type);
static void bash_init_regular_expressions (void);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
void bash_start_shell (Bash* self);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path, gboolean show_message);
gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands, const gchar* script_path, gboolean force_locale, gboolean supress_errors);
gboolean async_task_begin (AsyncTask* self);
void tee_jee_logging_log_debug (const gchar* message);
void tee_jee_system_sleep (gint milliseconds);
gint* tee_jee_process_helper_get_process_children (GPid parent_pid, int* result_length1);
static void bash_real_parse_stdout_line (AsyncTask* base, const gchar* out_line);
static void bash_real_parse_stderr_line (AsyncTask* base, const gchar* err_line);
gint bash_execute (Bash* self, const gchar* line);
void async_task_write_stdin (AsyncTask* self, const gchar* line);
void tee_jee_gtk_helper_gtk_do_events (void);
static void bash_real_finish_task (AsyncTask* base);
gint bash_read_status (Bash* self);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static void bash_finalize (GObject * obj);


Bash* bash_construct (GType object_type) {
	Bash * self = NULL;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self = (Bash*) async_task_construct (object_type);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	bash_init_regular_expressions ();
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	return self;
#line 163 "Bash.c"
}


Bash* bash_new (void) {
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	return bash_construct (TYPE_BASH);
#line 170 "Bash.c"
}


static void bash_init_regular_expressions (void) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GError * _inner_error_ = NULL;
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp0_ = bash_regex_list;
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	if (_tmp0_ != NULL) {
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		return;
#line 184 "Bash.c"
	}
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_REGEX, (GBoxedCopyFunc) g_regex_ref, (GDestroyNotify) g_regex_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_object_unref0 (bash_regex_list);
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	bash_regex_list = _tmp1_;
#line 192 "Bash.c"
	{
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_;
		GeeHashMap* _tmp4_;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp3_ = g_regex_new ("status=([0-9\\-]+)", 0, 0, &_inner_error_);
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp2_ = _tmp3_;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 203 "Bash.c"
			goto __catch37_g_error;
		}
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp4_ = bash_regex_list;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, "status", _tmp2_);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_regex_unref0 (_tmp2_);
#line 212 "Bash.c"
	}
	goto __finally37;
	__catch37_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		e = _inner_error_;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_inner_error_ = NULL;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp5_ = e;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp6_ = _tmp5_->message;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_error_free0 (e);
#line 232 "Bash.c"
	}
	__finally37:
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		return;
#line 243 "Bash.c"
	}
}


void bash_start_shell (Bash* self) {
	const gchar* _tmp0_;
	gchar* sh = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	AppStatus _tmp6_;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	g_return_if_fail (self != NULL);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp0_ = ((AsyncTask*) self)->working_dir;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	tee_jee_file_system_dir_create (_tmp0_, FALSE);
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp1_ = g_strdup ("bash -c 'pkexec bash'");
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	sh = _tmp1_;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp2_ = sh;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp3_ = ((AsyncTask*) self)->script_file;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp4_ = tee_jee_process_helper_save_bash_script_temp (_tmp2_, _tmp3_, TRUE, FALSE);
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp5_ = _tmp4_;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_free0 (_tmp5_);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	async_task_begin ((AsyncTask*) self);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	tee_jee_logging_log_debug ("Started bash shell");
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp6_ = ((AsyncTask*) self)->status;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	if (_tmp6_ == APP_STATUS_RUNNING) {
#line 285 "Bash.c"
		GPid _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GPid _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		self->bash_pid = (GPid) -1;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		while (TRUE) {
#line 296 "Bash.c"
			gboolean _tmp7_ = FALSE;
			AppStatus _tmp8_;
			gint* children = NULL;
			GPid _tmp10_;
			gint _tmp11_;
			gint* _tmp12_;
			gint children_length1;
			gint _children_size_;
			gint* _tmp13_;
			gint _tmp13__length1;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			_tmp8_ = ((AsyncTask*) self)->status;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			if (_tmp8_ == APP_STATUS_RUNNING) {
#line 311 "Bash.c"
				GPid _tmp9_;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				_tmp9_ = self->bash_pid;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				_tmp7_ = _tmp9_ == ((GPid) -1);
#line 317 "Bash.c"
			} else {
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				_tmp7_ = FALSE;
#line 321 "Bash.c"
			}
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			if (!_tmp7_) {
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				break;
#line 327 "Bash.c"
			}
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			tee_jee_system_sleep (200);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			_tmp10_ = ((AsyncTask*) self)->child_pid;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			_tmp12_ = tee_jee_process_helper_get_process_children (_tmp10_, &_tmp11_);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			children = _tmp12_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			children_length1 = _tmp11_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			_children_size_ = children_length1;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			_tmp13_ = children;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			_tmp13__length1 = children_length1;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			if (_tmp13__length1 > 0) {
#line 347 "Bash.c"
				gint* _tmp14_;
				gint _tmp14__length1;
				gint _tmp15_;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				_tmp14_ = children;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				_tmp14__length1 = children_length1;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				_tmp15_ = _tmp14_[0];
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
				self->bash_pid = (GPid) _tmp15_;
#line 359 "Bash.c"
			}
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			children = (g_free (children), NULL);
#line 363 "Bash.c"
		}
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp16_ = ((AsyncTask*) self)->child_pid;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp17_ = g_strdup_printf ("script pid: %d", (gint) _tmp16_);
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp18_ = _tmp17_;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		tee_jee_logging_log_debug (_tmp18_);
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_free0 (_tmp18_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp19_ = self->bash_pid;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp20_ = g_strdup_printf ("bash shell pid: %d", (gint) _tmp19_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp21_ = _tmp20_;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		tee_jee_logging_log_debug (_tmp21_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_free0 (_tmp21_);
#line 385 "Bash.c"
	}
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_free0 (sh);
#line 389 "Bash.c"
}


static void bash_real_parse_stdout_line (AsyncTask* base, const gchar* out_line) {
	Bash * self;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GMatchInfo* match = NULL;
	GeeHashMap* _tmp5_;
	gpointer _tmp6_;
	GRegex* _tmp7_;
	const gchar* _tmp8_;
	GMatchInfo* _tmp9_ = NULL;
	gboolean _tmp10_;
	gboolean _tmp11_;
	FILE* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	FILE* _tmp20_;
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self = (Bash*) base;
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	g_return_if_fail (out_line != NULL);
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp1_ = out_line;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	if (_tmp1_ == NULL) {
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp0_ = TRUE;
#line 420 "Bash.c"
	} else {
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp2_ = out_line;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp3_ = strlen (_tmp2_);
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp4_ = _tmp3_;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp0_ = _tmp4_ == 0;
#line 433 "Bash.c"
	}
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	if (_tmp0_) {
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		return;
#line 439 "Bash.c"
	}
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp5_ = bash_regex_list;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, "status");
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp7_ = (GRegex*) _tmp6_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp8_ = out_line;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp10_ = g_regex_match (_tmp7_, _tmp8_, 0, &_tmp9_);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_match_info_unref0 (match);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	match = _tmp9_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp11_ = _tmp10_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_regex_unref0 (_tmp7_);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	if (_tmp11_) {
#line 461 "Bash.c"
		GMatchInfo* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gint _tmp15_;
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp12_ = match;
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp13_ = g_match_info_fetch (_tmp12_, 1);
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp14_ = _tmp13_;
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp15_ = atoi (_tmp14_);
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		self->status_code = _tmp15_;
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_free0 (_tmp14_);
#line 478 "Bash.c"
	}
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp16_ = stdout;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp17_ = out_line;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp18_ = g_strconcat (_tmp17_, "\n", NULL);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp19_ = _tmp18_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	fprintf (_tmp16_, "%s", _tmp19_);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_free0 (_tmp19_);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp20_ = stdout;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	fflush (_tmp20_);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_match_info_unref0 (match);
#line 498 "Bash.c"
}


static void bash_real_parse_stderr_line (AsyncTask* base, const gchar* err_line) {
	Bash * self;
	FILE* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FILE* _tmp4_;
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self = (Bash*) base;
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	g_return_if_fail (err_line != NULL);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp0_ = stdout;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp1_ = err_line;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp2_ = g_strconcat (_tmp1_, "\n", NULL);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp3_ = _tmp2_;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	fprintf (_tmp0_, "%s", _tmp3_);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_free0 (_tmp3_);
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp4_ = stdout;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	fflush (_tmp4_);
#line 529 "Bash.c"
}


gint bash_execute (Bash* self, const gchar* line) {
	gint result = 0;
	const gchar* _tmp0_;
	gint _tmp2_;
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	g_return_val_if_fail (line != NULL, 0);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self->status_code = -1;
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp0_ = line;
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	async_task_write_stdin ((AsyncTask*) self, _tmp0_);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	async_task_write_stdin ((AsyncTask*) self, "echo status=$?");
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	while (TRUE) {
#line 551 "Bash.c"
		gint _tmp1_;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp1_ = self->status_code;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		if (!(_tmp1_ == -1)) {
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
			break;
#line 559 "Bash.c"
		}
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		tee_jee_system_sleep (200);
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		tee_jee_gtk_helper_gtk_do_events ();
#line 565 "Bash.c"
	}
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp2_ = self->status_code;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	result = _tmp2_;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	return result;
#line 573 "Bash.c"
}


static void bash_real_finish_task (AsyncTask* base) {
	Bash * self;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self = (Bash*) base;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	tee_jee_logging_log_debug ("Bash: finish_task()");
#line 583 "Bash.c"
}


gint bash_read_status (Bash* self) {
	gint result = 0;
	gchar* status_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* f = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp0_ = ((AsyncTask*) self)->working_dir;
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/status", NULL);
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	status_file = _tmp1_;
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp2_ = status_file;
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	f = _tmp3_;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp4_ = f;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	if (_tmp5_) {
#line 617 "Bash.c"
		gchar* txt = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp6_ = status_file;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp7_ = tee_jee_file_system_file_read (_tmp6_);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		txt = _tmp7_;
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp8_ = txt;
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_tmp9_ = atoi (_tmp8_);
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		result = _tmp9_;
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_free0 (txt);
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_object_unref0 (f);
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		_g_free0 (status_file);
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
		return result;
#line 643 "Bash.c"
	}
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	result = -1;
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_object_unref0 (f);
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	_g_free0 (status_file);
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	return result;
#line 653 "Bash.c"
}


static void bash_class_init (BashClass * klass) {
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	bash_parent_class = g_type_class_peek_parent (klass);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask *, const gchar*)) bash_real_parse_stdout_line;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask *, const gchar*)) bash_real_parse_stderr_line;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask *)) bash_real_finish_task;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	G_OBJECT_CLASS (klass)->finalize = bash_finalize;
#line 668 "Bash.c"
}


static void bash_instance_init (Bash * self) {
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self->bash_pid = (GPid) -1;
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self->status_code = -1;
#line 677 "Bash.c"
}


static void bash_finalize (GObject * obj) {
	Bash * self;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BASH, Bash);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Bash.vala"
	G_OBJECT_CLASS (bash_parent_class)->finalize (obj);
#line 687 "Bash.c"
}


GType bash_get_type (void) {
	static volatile gsize bash_type_id__volatile = 0;
	if (g_once_init_enter (&bash_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BashClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bash_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bash), 0, (GInstanceInitFunc) bash_instance_init, NULL };
		GType bash_type_id;
		bash_type_id = g_type_register_static (TYPE_ASYNC_TASK, "Bash", &g_define_type_info, 0);
		g_once_init_leave (&bash_type_id__volatile, bash_type_id);
	}
	return bash_type_id__volatile;
}



