/* TimeoutCounter.c generated by valac 0.38.10, the Vala compiler
 * generated from TimeoutCounter.vala, do not modify */

/*
 * TimeoutCounter.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define TYPE_TIMEOUT_COUNTER (timeout_counter_get_type ())
#define TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounter))
#define TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))
#define IS_TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMEOUT_COUNTER))
#define IS_TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMEOUT_COUNTER))
#define TIMEOUT_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))

typedef struct _TimeoutCounter TimeoutCounter;
typedef struct _TimeoutCounterClass TimeoutCounterClass;
typedef struct _TimeoutCounterPrivate TimeoutCounterPrivate;
enum  {
	TIMEOUT_COUNTER_0_PROPERTY,
	TIMEOUT_COUNTER_NUM_PROPERTIES
};
static GParamSpec* timeout_counter_properties[TIMEOUT_COUNTER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TimeoutCounter {
	GObject parent_instance;
	TimeoutCounterPrivate * priv;
	gboolean active;
	gchar* process_to_kill;
	gint seconds_to_wait;
	gboolean exit_app;
};

struct _TimeoutCounterClass {
	GObjectClass parent_class;
};


static gpointer timeout_counter_parent_class = NULL;

GType timeout_counter_get_type (void) G_GNUC_CONST;
#define TIMEOUT_COUNTER_DEFAULT_SECONDS_TO_WAIT 60
void timeout_counter_kill_process_on_timeout (TimeoutCounter* self, const gchar* process_to_kill, gint seconds_to_wait, gboolean exit_app);
void timeout_counter_start_counter_thread (TimeoutCounter* self);
static gpointer _timeout_counter_start_counter_thread_gthread_func (gpointer self);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
void timeout_counter_exit_on_timeout (TimeoutCounter* self, gint seconds_to_wait);
void timeout_counter_stop (TimeoutCounter* self);
void tee_jee_logging_log_debug (const gchar* message);
void exit (gint exit_code);
TimeoutCounter* timeout_counter_new (void);
TimeoutCounter* timeout_counter_construct (GType object_type);
static void timeout_counter_finalize (GObject * obj);


static gpointer _timeout_counter_start_counter_thread_gthread_func (gpointer self) {
	gpointer result;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	timeout_counter_start_counter_thread ((TimeoutCounter*) self);
#line 88 "TimeoutCounter.c"
	result = NULL;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	g_object_unref (self);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	return result;
#line 94 "TimeoutCounter.c"
}


void timeout_counter_kill_process_on_timeout (TimeoutCounter* self, const gchar* process_to_kill, gint seconds_to_wait, gboolean exit_app) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	g_return_if_fail (process_to_kill != NULL);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp0_ = process_to_kill;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_g_free0 (self->process_to_kill);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->process_to_kill = _tmp1_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp2_ = seconds_to_wait;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->seconds_to_wait = _tmp2_;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp3_ = exit_app;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->exit_app = _tmp3_;
#line 124 "TimeoutCounter.c"
	{
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		self->active = TRUE;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		g_thread_create (_timeout_counter_start_counter_thread_gthread_func, g_object_ref (self), TRUE, &_inner_error_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 132 "TimeoutCounter.c"
			goto __catch100_g_error;
		}
	}
	goto __finally100;
	__catch100_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		e = _inner_error_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_inner_error_ = NULL;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp4_ = e;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp5_ = _tmp4_->message;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		tee_jee_logging_log_error (_tmp5_, FALSE, FALSE);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_g_error_free0 (e);
#line 154 "TimeoutCounter.c"
	}
	__finally100:
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		g_clear_error (&_inner_error_);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		return;
#line 165 "TimeoutCounter.c"
	}
}


void timeout_counter_exit_on_timeout (TimeoutCounter* self, gint seconds_to_wait) {
	gchar* _tmp0_;
	gint _tmp1_;
	GError * _inner_error_ = NULL;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp0_ = g_strdup ("");
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_g_free0 (self->process_to_kill);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->process_to_kill = _tmp0_;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp1_ = seconds_to_wait;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->seconds_to_wait = _tmp1_;
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->exit_app = TRUE;
#line 188 "TimeoutCounter.c"
	{
#line 60 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		self->active = TRUE;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		g_thread_create (_timeout_counter_start_counter_thread_gthread_func, g_object_ref (self), TRUE, &_inner_error_);
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 196 "TimeoutCounter.c"
			goto __catch101_g_error;
		}
	}
	goto __finally101;
	__catch101_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		e = _inner_error_;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_inner_error_ = NULL;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp2_ = e;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp3_ = _tmp2_->message;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		tee_jee_logging_log_error (_tmp3_, FALSE, FALSE);
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_g_error_free0 (e);
#line 218 "TimeoutCounter.c"
	}
	__finally101:
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		g_clear_error (&_inner_error_);
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		return;
#line 229 "TimeoutCounter.c"
	}
}


void timeout_counter_stop (TimeoutCounter* self) {
#line 68 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->active = FALSE;
#line 239 "TimeoutCounter.c"
}


void timeout_counter_start_counter_thread (TimeoutCounter* self) {
	gint secs = 0;
	gboolean _tmp5_;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	secs = 0;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	while (TRUE) {
#line 252 "TimeoutCounter.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
		gint _tmp4_;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp1_ = self->active;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		if (_tmp1_) {
#line 260 "TimeoutCounter.c"
			gint _tmp2_;
			gint _tmp3_;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp2_ = secs;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp3_ = self->seconds_to_wait;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp0_ = _tmp2_ < _tmp3_;
#line 269 "TimeoutCounter.c"
		} else {
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp0_ = FALSE;
#line 273 "TimeoutCounter.c"
		}
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		if (!_tmp0_) {
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			break;
#line 279 "TimeoutCounter.c"
		}
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		g_usleep (((gulong) G_TIME_SPAN_MILLISECOND) * 1000);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp4_ = secs;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		secs = _tmp4_ + 1;
#line 287 "TimeoutCounter.c"
	}
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp5_ = self->active;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	if (_tmp5_) {
#line 293 "TimeoutCounter.c"
		FILE* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gboolean _tmp18_;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		self->active = FALSE;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp6_ = stdout;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		fprintf (_tmp6_, "\n");
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp7_ = self->process_to_kill;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp8_ = strlen (_tmp7_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp9_ = _tmp8_;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		if (_tmp9_ > 0) {
#line 313 "TimeoutCounter.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp10_ = self->process_to_kill;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp11_ = g_strconcat ("killall ", _tmp10_, NULL);
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp12_ = _tmp11_;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			system (_tmp12_);
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_g_free0 (_tmp12_);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp13_ = self->process_to_kill;
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp14_ = g_strdup_printf (": %s", _tmp13_);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp15_ = _tmp14_;
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp16_ = g_strconcat ("[timeout] Killed process", _tmp15_, NULL);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_tmp17_ = _tmp16_;
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			tee_jee_logging_log_debug (_tmp17_);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_g_free0 (_tmp17_);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			_g_free0 (_tmp15_);
#line 348 "TimeoutCounter.c"
		}
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		_tmp18_ = self->exit_app;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
		if (_tmp18_) {
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			tee_jee_logging_log_debug ("[timeout] Exit application");
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
			exit (0);
#line 358 "TimeoutCounter.c"
		}
	}
}


TimeoutCounter* timeout_counter_construct (GType object_type) {
	TimeoutCounter * self = NULL;
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self = (TimeoutCounter*) g_object_new (object_type, NULL);
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	return self;
#line 370 "TimeoutCounter.c"
}


TimeoutCounter* timeout_counter_new (void) {
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	return timeout_counter_construct (TYPE_TIMEOUT_COUNTER);
#line 377 "TimeoutCounter.c"
}


static void timeout_counter_class_init (TimeoutCounterClass * klass) {
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	timeout_counter_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	G_OBJECT_CLASS (klass)->finalize = timeout_counter_finalize;
#line 386 "TimeoutCounter.c"
}


static void timeout_counter_instance_init (TimeoutCounter * self) {
	gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->active = FALSE;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_tmp0_ = g_strdup ("");
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->process_to_kill = _tmp0_;
#line 35 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->seconds_to_wait = 60;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self->exit_app = FALSE;
#line 402 "TimeoutCounter.c"
}


static void timeout_counter_finalize (GObject * obj) {
	TimeoutCounter * self;
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIMEOUT_COUNTER, TimeoutCounter);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	_g_free0 (self->process_to_kill);
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TimeoutCounter.vala"
	G_OBJECT_CLASS (timeout_counter_parent_class)->finalize (obj);
#line 414 "TimeoutCounter.c"
}


GType timeout_counter_get_type (void) {
	static volatile gsize timeout_counter_type_id__volatile = 0;
	if (g_once_init_enter (&timeout_counter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TimeoutCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timeout_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimeoutCounter), 0, (GInstanceInitFunc) timeout_counter_instance_init, NULL };
		GType timeout_counter_type_id;
		timeout_counter_type_id = g_type_register_static (G_TYPE_OBJECT, "TimeoutCounter", &g_define_type_info, 0);
		g_once_init_leave (&timeout_counter_type_id__volatile, timeout_counter_type_id);
	}
	return timeout_counter_type_id__volatile;
}



