/* RsyncTask.c generated by valac 0.38.10, the Vala compiler
 * generated from RsyncTask.vala, do not modify */

/*
 * RsyncTask.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;

#define TYPE_APP_STATUS (app_status_get_type ())

#define TYPE_RSYNC_TASK (rsync_task_get_type ())
#define RSYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSYNC_TASK, RsyncTask))
#define RSYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSYNC_TASK, RsyncTaskClass))
#define IS_RSYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSYNC_TASK))
#define IS_RSYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSYNC_TASK))
#define RSYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSYNC_TASK, RsyncTaskClass))

typedef struct _RsyncTask RsyncTask;
typedef struct _RsyncTaskClass RsyncTaskClass;
typedef struct _RsyncTaskPrivate RsyncTaskPrivate;
enum  {
	RSYNC_TASK_0_PROPERTY,
	RSYNC_TASK_NUM_PROPERTIES
};
static GParamSpec* rsync_task_properties[RSYNC_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_queue_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_queue_free__g_free0_ (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_FILE_ITEM (file_item_get_type ())
#define FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_ITEM, FileItem))
#define FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_ITEM, FileItemClass))
#define IS_FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_ITEM))
#define IS_FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_ITEM))
#define FILE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_ITEM, FileItemClass))

typedef struct _FileItem FileItem;
typedef struct _FileItemClass FileItemClass;
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
typedef struct _FileItemPrivate FileItemPrivate;

typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	gchar* status_line;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _RsyncTask {
	AsyncTask parent_instance;
	RsyncTaskPrivate * priv;
	gboolean delete_extra;
	gboolean delete_after;
	gboolean delete_excluded;
	gboolean relative;
	gchar* rsync_log_file;
	gchar* exclude_from_file;
	gchar* link_from_path;
	gchar* source_path;
	gchar* dest_path;
	gboolean verbose;
	gboolean io_nice;
	gboolean dry_run;
	GQueue* status_lines;
	gint64 status_line_count;
	gint64 total_size;
	gint64 count_created;
	gint64 count_deleted;
	gint64 count_modified;
	gint64 count_checksum;
	gint64 count_size;
	gint64 count_timestamp;
	gint64 count_permissions;
	gint64 count_owner;
	gint64 count_group;
	gint64 count_unchanged;
	GString* log;
};

struct _RsyncTaskClass {
	AsyncTaskClass parent_class;
};

struct _RsyncTaskPrivate {
	GeeHashMap* regex_list;
};

struct _FileItem {
	GObject parent_instance;
	FileItemPrivate * priv;
	gchar* file_name;
	gchar* file_location;
	gchar* file_path;
	gchar* file_path_prefix;
	GFileType file_type;
	GDateTime* modified;
	gchar* permissions;
	gchar* owner_user;
	gchar* owner_group;
	gchar* content_type;
	gchar* file_status;
	gboolean is_selected;
	gboolean is_symlink;
	gchar* symlink_target;
	gboolean is_archive;
	gboolean is_stale;
	FileItem* parent;
	GeeHashMap* children;
	FileItem* source_archive;
	GObject* tag;
	glong file_count;
	glong dir_count;
	glong file_count_total;
	glong dir_count_total;
	GIcon* icon;
	gboolean is_dummy;
};

struct _FileItemClass {
	GObjectClass parent_class;
};


static gpointer rsync_task_parent_class = NULL;

GType async_task_get_type (void) G_GNUC_CONST;
GType app_status_get_type (void) G_GNUC_CONST;
GType rsync_task_get_type (void) G_GNUC_CONST;
#define RSYNC_TASK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_RSYNC_TASK, RsyncTaskPrivate))
static void _g_free0_ (gpointer var);
static inline void _g_queue_free__g_free0_ (GQueue* self);
RsyncTask* rsync_task_new (void);
RsyncTask* rsync_task_construct (GType object_type);
AsyncTask* async_task_construct (GType object_type);
static void rsync_task_init_regular_expressions (RsyncTask* self);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
void rsync_task_prepare (RsyncTask* self);
static gchar* rsync_task_build_script (RsyncTask* self);
void tee_jee_logging_log_debug (const gchar* message);
gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands, const gchar* script_path, gboolean force_locale, gboolean supress_errors);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
GType file_item_get_type (void) G_GNUC_CONST;
GeeArrayList* rsync_task_parse_log (RsyncTask* self, const gchar* log_file_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gint64 tee_jee_file_system_file_line_count (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1, const gchar* path2);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
FileItem* file_item_new_from_disk_path_with_basic_info (const gchar* _file_path);
FileItem* file_item_construct_from_disk_path_with_basic_info (GType object_type, const gchar* _file_path);
void tee_jee_logging_log_msg (const gchar* message, gboolean highlight);
gboolean tee_jee_file_system_file_gzip (const gchar* src_file);
void rsync_task_execute (RsyncTask* self);
gboolean async_task_begin (AsyncTask* self);
static void rsync_task_real_parse_stdout_line (AsyncTask* base, const gchar* out_line);
gboolean rsync_task_update_progress_parse_console_output (RsyncTask* self, const gchar* line);
static void rsync_task_real_parse_stderr_line (AsyncTask* base, const gchar* err_line);
static void rsync_task_real_finish_task (AsyncTask* base);
gboolean tee_jee_file_system_file_write (const gchar* file_path, const gchar* contents);
gint rsync_task_read_status (RsyncTask* self);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static void rsync_task_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _g_free0_ (gpointer var) {
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	var = (g_free (var), NULL);
#line 248 "RsyncTask.c"
}


static inline void _g_queue_free__g_free0_ (GQueue* self) {
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_free0_);
#line 255 "RsyncTask.c"
}


RsyncTask* rsync_task_construct (GType object_type) {
	RsyncTask * self = NULL;
	GQueue* _tmp0_;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self = (RsyncTask*) async_task_construct (object_type);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	rsync_task_init_regular_expressions (self);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = g_queue_new ();
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	__g_queue_free__g_free0_0 (self->status_lines);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->status_lines = _tmp0_;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	return self;
#line 274 "RsyncTask.c"
}


RsyncTask* rsync_task_new (void) {
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	return rsync_task_construct (TYPE_RSYNC_TASK);
#line 281 "RsyncTask.c"
}


static void rsync_task_init_regular_expressions (RsyncTask* self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GError * _inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = self->priv->regex_list;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp0_ != NULL) {
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		return;
#line 297 "RsyncTask.c"
	}
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_REGEX, (GBoxedCopyFunc) g_regex_ref, (GDestroyNotify) g_regex_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_object_unref0 (self->priv->regex_list);
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->priv->regex_list = _tmp1_;
#line 305 "RsyncTask.c"
	{
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_;
		GeeHashMap* _tmp4_;
		GRegex* _tmp5_ = NULL;
		GRegex* _tmp6_;
		GeeHashMap* _tmp7_;
		GRegex* _tmp8_ = NULL;
		GRegex* _tmp9_;
		GeeHashMap* _tmp10_;
		GRegex* _tmp11_ = NULL;
		GRegex* _tmp12_;
		GeeHashMap* _tmp13_;
		GRegex* _tmp14_ = NULL;
		GRegex* _tmp15_;
		GeeHashMap* _tmp16_;
		GRegex* _tmp17_ = NULL;
		GRegex* _tmp18_;
		GeeHashMap* _tmp19_;
		GRegex* _tmp20_ = NULL;
		GRegex* _tmp21_;
		GeeHashMap* _tmp22_;
		GRegex* _tmp23_ = NULL;
		GRegex* _tmp24_;
		GeeHashMap* _tmp25_;
		GRegex* _tmp26_ = NULL;
		GRegex* _tmp27_;
		GeeHashMap* _tmp28_;
		GRegex* _tmp29_ = NULL;
		GRegex* _tmp30_;
		GeeHashMap* _tmp31_;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp3_ = g_regex_new ("([<>ch.*])([.fdLDS])(c|\\+|\\.| )(s|\\+|\\.| )(t|\\+|\\.| )(p|\\+|\\.|" \
" )(o|\\+|\\.| )(g|\\+|\\.| )(u|\\+|\\.| )(a|\\+|\\.| )(x|\\+|\\.| ) (." \
"*)", 0, 0, &_inner_error_);
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp2_ = _tmp3_;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 343 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp4_ = self->priv->regex_list;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, "status", _tmp2_);
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp6_ = g_regex_new ("([<>ch.*])([.fdLDS])[+]{9} (.*)", 0, 0, &_inner_error_);
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp5_ = _tmp6_;
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 358 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp7_ = self->priv->regex_list;
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, "created", _tmp5_);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp9_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] ([<>ch.*])([.fdLDS])[+]{9} (.*)", 0, 0, &_inner_error_);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp8_ = _tmp9_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 375 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp10_ = self->priv->regex_list;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, "log-created", _tmp8_);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp12_ = g_regex_new ("\\*deleting[ \\t]+(.*)", 0, 0, &_inner_error_);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp11_ = _tmp12_;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 394 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp13_ = self->priv->regex_list;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, "deleted", _tmp11_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp15_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] \\*deleting[ \\t]+(.*)", 0, 0, &_inner_error_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp14_ = _tmp15_;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 415 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp16_ = self->priv->regex_list;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, "log-deleted", _tmp14_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp18_ = g_regex_new ("([<>ch.])([.fdLDS])(c|\\+|\\.| )(s|\\+|\\.| )(t|\\+|\\.| )(p|\\+|\\.| " \
")(o|\\+|\\.| )(g|\\+|\\.| )(u|\\+|\\.| )(a|\\+|\\.| )(x|\\+|\\.) (.*)", 0, 0, &_inner_error_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp17_ = _tmp18_;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 438 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp19_ = self->priv->regex_list;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, "modified", _tmp17_);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp21_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] ([<>ch.])([.fdLDS])(c|\\+|\\.| )(s|\\+" \
"|\\.| )(t|\\+|\\.| )(p|\\+|\\.| )(o|\\+|\\.| )(g|\\+|\\.| )(u|\\+|\\.|" \
" )(a|\\+|\\.| )(x|\\+|\\.) (.*)", 0, 0, &_inner_error_);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp20_ = _tmp21_;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 463 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp22_ = self->priv->regex_list;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, "log-modified", _tmp20_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp24_ = g_regex_new ("([.h])([.fdLDS])[ ]{9} (.*)", 0, 0, &_inner_error_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp23_ = _tmp24_;
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp20_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 490 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp25_ = self->priv->regex_list;
#line 134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, "unchanged", _tmp23_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp27_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] ([.h])([.fdLDS])[ ]{9} (.*)", 0, 0, &_inner_error_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp26_ = _tmp27_;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp23_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp20_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 519 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp28_ = self->priv->regex_list;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, "log-unchanged", _tmp26_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp30_ = g_regex_new ("total size is ([0-9,]+)[ \\t]+speedup is [0-9.]+", 0, 0, &_inner_error_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp29_ = _tmp30_;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp26_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp23_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp20_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 550 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp31_ = self->priv->regex_list;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp31_, "total-size", _tmp29_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp29_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp26_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp23_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp20_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp17_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp14_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp11_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp8_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp5_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp2_);
#line 577 "RsyncTask.c"
	}
	goto __finally60;
	__catch60_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		e = _inner_error_;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_inner_error_ = NULL;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp32_ = e;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp33_ = _tmp32_->message;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		tee_jee_logging_log_error (_tmp33_, FALSE, FALSE);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_error_free0 (e);
#line 597 "RsyncTask.c"
	}
	__finally60:
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		return;
#line 608 "RsyncTask.c"
	}
}


void rsync_task_prepare (RsyncTask* self) {
	gchar* script_text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GString* _tmp7_;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = rsync_task_build_script (self);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	script_text = _tmp0_;
#line 152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	tee_jee_logging_log_debug (script_text);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = ((AsyncTask*) self)->script_file;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp2_ = tee_jee_process_helper_save_bash_script_temp (script_text, _tmp1_, TRUE, FALSE);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp3_ = _tmp2_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp3_);
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp4_ = ((AsyncTask*) self)->script_file;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp5_ = g_strdup_printf ("RsyncTask:prepare(): saved: %s", _tmp4_);
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp6_ = _tmp5_;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	tee_jee_logging_log_debug (_tmp6_);
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp6_);
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->status_line_count = (gint64) 0;
#line 159 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->total_size = (gint64) 0;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_created = (gint64) 0;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_deleted = (gint64) 0;
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_modified = (gint64) 0;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_checksum = (gint64) 0;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_size = (gint64) 0;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_timestamp = (gint64) 0;
#line 167 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_permissions = (gint64) 0;
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_owner = (gint64) 0;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_group = (gint64) 0;
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->count_unchanged = (gint64) 0;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp7_ = g_string_new ("");
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_string_free0 (self->log);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->log = _tmp7_;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (script_text);
#line 681 "RsyncTask.c"
}


static gchar* rsync_task_build_script (RsyncTask* self) {
	gchar* result = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp11_;
	gboolean _tmp14_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp24_;
	const gchar* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	const gchar* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	const gchar* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	gchar* _tmp69_;
	const gchar* _tmp70_;
	const gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	cmd = _tmp0_;
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = self->io_nice;
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp1_) {
#line 740 "RsyncTask.c"
	}
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp2_ = cmd;
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp3_ = g_strconcat (_tmp2_, "rsync -aii", NULL);
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	cmd = _tmp3_;
#line 189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp4_ = cmd;
#line 189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp5_ = g_strconcat (_tmp4_, " --recursive", NULL);
#line 189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	cmd = _tmp5_;
#line 191 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp6_ = self->verbose;
#line 191 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp6_) {
#line 762 "RsyncTask.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp7_ = cmd;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp8_ = g_strconcat (_tmp7_, " --verbose", NULL);
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp8_;
#line 773 "RsyncTask.c"
	} else {
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp9_ = cmd;
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp10_ = g_strconcat (_tmp9_, " --quiet", NULL);
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp10_;
#line 785 "RsyncTask.c"
	}
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp11_ = self->delete_extra;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp11_) {
#line 791 "RsyncTask.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp12_ = cmd;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp13_ = g_strconcat (_tmp12_, " --delete", NULL);
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp13_;
#line 802 "RsyncTask.c"
	}
#line 202 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp14_ = self->delete_after;
#line 202 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp14_) {
#line 808 "RsyncTask.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp15_ = cmd;
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp16_ = g_strconcat (_tmp15_, " --delete-after", NULL);
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp16_;
#line 819 "RsyncTask.c"
	}
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp17_ = cmd;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp18_ = g_strconcat (_tmp17_, " --force", NULL);
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	cmd = _tmp18_;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp19_ = cmd;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp20_ = g_strconcat (_tmp19_, " --stats", NULL);
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	cmd = _tmp20_;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp21_ = self->delete_excluded;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp21_) {
#line 841 "RsyncTask.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp22_ = cmd;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp23_ = g_strconcat (_tmp22_, " --delete-excluded", NULL);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp23_;
#line 852 "RsyncTask.c"
	}
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp24_ = self->dry_run;
#line 220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp24_) {
#line 858 "RsyncTask.c"
		const gchar* _tmp25_;
		gchar* _tmp26_;
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp25_ = cmd;
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp26_ = g_strconcat (_tmp25_, " --dry-run", NULL);
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp26_;
#line 869 "RsyncTask.c"
	}
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp27_ = self->link_from_path;
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp28_ = strlen (_tmp27_);
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp29_ = _tmp28_;
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp29_ > 0) {
#line 879 "RsyncTask.c"
		const gchar* _tmp30_;
		gboolean _tmp31_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp30_ = self->link_from_path;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp31_ = g_str_has_suffix (_tmp30_, "/");
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (!_tmp31_) {
#line 895 "RsyncTask.c"
			const gchar* _tmp32_;
			gchar* _tmp33_;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp32_ = self->link_from_path;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp33_ = g_strdup_printf ("%s/", _tmp32_);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (self->link_from_path);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			self->link_from_path = _tmp33_;
#line 906 "RsyncTask.c"
		}
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp34_ = cmd;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp35_ = self->link_from_path;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp36_ = tee_jee_file_system_escape_single_quote (_tmp35_);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp37_ = _tmp36_;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp38_ = g_strdup_printf (" --link-dest='%s'", _tmp37_);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp39_ = _tmp38_;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp40_ = g_strconcat (_tmp34_, _tmp39_, NULL);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp40_;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp39_);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp37_);
#line 930 "RsyncTask.c"
	}
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp41_ = self->rsync_log_file;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp42_ = strlen (_tmp41_);
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp43_ = _tmp42_;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp43_ > 0) {
#line 940 "RsyncTask.c"
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp44_ = cmd;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp45_ = self->rsync_log_file;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp46_ = tee_jee_file_system_escape_single_quote (_tmp45_);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp47_ = _tmp46_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp48_ = g_strdup_printf (" --log-file='%s'", _tmp47_);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp49_ = _tmp48_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp50_ = g_strconcat (_tmp44_, _tmp49_, NULL);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp50_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp49_);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp47_);
#line 970 "RsyncTask.c"
	}
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp51_ = self->exclude_from_file;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp52_ = strlen (_tmp51_);
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp53_ = _tmp52_;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp53_ > 0) {
#line 980 "RsyncTask.c"
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		gboolean _tmp61_ = FALSE;
		gboolean _tmp62_;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp54_ = cmd;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp55_ = self->exclude_from_file;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp56_ = tee_jee_file_system_escape_single_quote (_tmp55_);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp57_ = _tmp56_;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp58_ = g_strdup_printf (" --exclude-from='%s'", _tmp57_);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp59_ = _tmp58_;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp60_ = g_strconcat (_tmp54_, _tmp59_, NULL);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		cmd = _tmp60_;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp59_);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp57_);
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp62_ = self->delete_extra;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (_tmp62_) {
#line 1016 "RsyncTask.c"
			gboolean _tmp63_;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp63_ = self->delete_excluded;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp61_ = _tmp63_;
#line 1022 "RsyncTask.c"
		} else {
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp61_ = FALSE;
#line 1026 "RsyncTask.c"
		}
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (_tmp61_) {
#line 1030 "RsyncTask.c"
			const gchar* _tmp64_;
			gchar* _tmp65_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp64_ = cmd;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp65_ = g_strconcat (_tmp64_, " --delete-excluded", NULL);
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (cmd);
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			cmd = _tmp65_;
#line 1041 "RsyncTask.c"
		}
	}
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp66_ = self->source_path;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp67_ = tee_jee_file_system_remove_trailing_slash (_tmp66_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (self->source_path);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->source_path = _tmp67_;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp68_ = self->dest_path;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp69_ = tee_jee_file_system_remove_trailing_slash (_tmp68_);
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (self->dest_path);
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->dest_path = _tmp69_;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp70_ = cmd;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp71_ = self->source_path;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp72_ = tee_jee_file_system_escape_single_quote (_tmp71_);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp73_ = _tmp72_;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp74_ = g_strdup_printf (" '%s/'", _tmp73_);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp75_ = _tmp74_;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp76_ = g_strconcat (_tmp70_, _tmp75_, NULL);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	cmd = _tmp76_;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp75_);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp73_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp77_ = cmd;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp78_ = self->dest_path;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp79_ = tee_jee_file_system_escape_single_quote (_tmp78_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp80_ = _tmp79_;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp81_ = g_strdup_printf (" '%s/'", _tmp80_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp82_ = _tmp81_;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp83_ = g_strconcat (_tmp77_, _tmp82_, NULL);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	cmd = _tmp83_;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp82_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp80_);
#line 252 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	result = cmd;
#line 252 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	return result;
#line 1108 "RsyncTask.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 1131 "RsyncTask.c"
}


GeeArrayList* rsync_task_parse_log (RsyncTask* self, const gchar* log_file_path) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* log_file = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GDataOutputStream* dos_changes = NULL;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	gint64 _tmp26_;
	GDataOutputStream* _tmp203_;
	GError * _inner_error_ = NULL;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_val_if_fail (log_file_path != NULL, NULL);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = gee_array_list_new (TYPE_FILE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	list = _tmp0_;
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = log_file_path;
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	log_file = _tmp2_;
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	dos_changes = NULL;
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp3_ = log_file;
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp4_ = g_str_has_suffix (_tmp3_, "-changes");
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (!_tmp4_) {
#line 1174 "RsyncTask.c"
		gchar* log_file_changes = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_;
#line 264 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp5_ = log_file_path;
#line 264 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp6_ = g_strconcat (_tmp5_, "-changes", NULL);
#line 264 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		log_file_changes = _tmp6_;
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp7_ = log_file_changes;
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp8_ = tee_jee_file_system_file_exists (_tmp7_);
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (_tmp8_) {
#line 1192 "RsyncTask.c"
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp9_ = log_file_changes;
#line 268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (log_file);
#line 268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			log_file = _tmp10_;
#line 1203 "RsyncTask.c"
		} else {
			{
				GFile* file = NULL;
				const gchar* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp13_;
				gboolean _tmp14_;
				GFileOutputStream* file_stream = NULL;
				GFile* _tmp16_;
				GFileOutputStream* _tmp17_;
				GFileOutputStream* _tmp18_;
				GDataOutputStream* _tmp19_;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp11_ = log_file_changes;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp12_ = g_file_new_for_path (_tmp11_);
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				file = _tmp12_;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp13_ = file;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp14_ = g_file_query_exists (_tmp13_, NULL);
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				if (_tmp14_) {
#line 1228 "RsyncTask.c"
					GFile* _tmp15_;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp15_ = file;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					g_file_delete (_tmp15_, NULL, &_inner_error_);
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_object_unref0 (file);
#line 1238 "RsyncTask.c"
						goto __catch61_g_error;
					}
				}
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp16_ = file;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp17_ = g_file_create (_tmp16_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				file_stream = _tmp17_;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_object_unref0 (file);
#line 1252 "RsyncTask.c"
					goto __catch61_g_error;
				}
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp18_ = file_stream;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp19_ = g_data_output_stream_new ((GOutputStream*) _tmp18_);
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (dos_changes);
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				dos_changes = _tmp19_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (file_stream);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (file);
#line 1267 "RsyncTask.c"
			}
			goto __finally61;
			__catch61_g_error:
			{
				GError* e = NULL;
				GError* _tmp20_;
				const gchar* _tmp21_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				e = _inner_error_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_inner_error_ = NULL;
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp20_ = e;
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp21_ = _tmp20_->message;
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				tee_jee_logging_log_error (_tmp21_, FALSE, FALSE);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_error_free0 (e);
#line 1287 "RsyncTask.c"
			}
			__finally61:
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (log_file_changes);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (dos_changes);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (log_file);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (list);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				g_clear_error (&_inner_error_);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				return NULL;
#line 1306 "RsyncTask.c"
			}
		}
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (log_file_changes);
#line 1311 "RsyncTask.c"
	}
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	tee_jee_logging_log_debug ("RsyncTask: parse_log()");
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp22_ = log_file;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp23_ = g_strdup_printf ("log_file = %s", _tmp22_);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp24_ = _tmp23_;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	tee_jee_logging_log_debug (_tmp24_);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp24_);
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	((AsyncTask*) self)->prg_count = (gint64) 0;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp25_ = log_file;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp26_ = tee_jee_file_system_file_line_count (_tmp25_);
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	((AsyncTask*) self)->prg_count_total = _tmp26_;
#line 1333 "RsyncTask.c"
	{
		gchar* line = NULL;
		GFile* file = NULL;
		const gchar* _tmp27_;
		GFile* _tmp28_;
		GFile* _tmp29_;
		gboolean _tmp30_;
		GFileInputStream* _tmp36_ = NULL;
		GFile* _tmp37_;
		GFileInputStream* _tmp38_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp39_;
		gchar* item_path = NULL;
		gchar* _tmp40_;
		gchar* item_disk_path = NULL;
		gchar* _tmp41_;
		gchar* item_status = NULL;
		gchar* _tmp42_;
		gchar* item_basepath = NULL;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp27_ = log_file;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp28_ = g_file_new_for_path (_tmp27_);
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		file = _tmp28_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp29_ = file;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp30_ = g_file_query_exists (_tmp29_, NULL);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (!_tmp30_) {
#line 1370 "RsyncTask.c"
			const gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp31_ = log_file;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp32_ = g_strdup_printf (": %s", _tmp31_);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp33_ = _tmp32_;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp34_ = g_strconcat (_ ("File not found"), _tmp33_, NULL);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp35_ = _tmp34_;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			tee_jee_logging_log_error (_tmp35_, FALSE, FALSE);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (_tmp35_);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (_tmp33_);
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			result = list;
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_object_unref0 (file);
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (line);
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_object_unref0 (dos_changes);
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (log_file);
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			return result;
#line 1404 "RsyncTask.c"
		}
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp37_ = file;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp38_ = g_file_read (_tmp37_, NULL, &_inner_error_);
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp36_ = _tmp38_;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_object_unref0 (file);
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (line);
#line 1418 "RsyncTask.c"
			goto __catch62_g_error;
		}
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp39_ = g_data_input_stream_new ((GInputStream*) _tmp36_);
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		dis = _tmp39_;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp40_ = g_strdup ("");
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		item_path = _tmp40_;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp41_ = g_strdup ("");
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		item_disk_path = _tmp41_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp42_ = g_strdup ("");
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		item_status = _tmp42_;
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp43_ = log_file_path;
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp44_ = tee_jee_file_system_file_parent (_tmp43_);
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp45_ = _tmp44_;
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp46_ = tee_jee_file_system_path_combine (_tmp45_, "localhost");
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp47_ = _tmp46_;
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp45_);
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		item_basepath = _tmp47_;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		while (TRUE) {
#line 1453 "RsyncTask.c"
			gchar* _tmp48_ = NULL;
			GDataInputStream* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			const gchar* _tmp52_;
			gint64 _tmp53_;
			const gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gint _tmp57_;
			gint _tmp58_;
			gboolean _tmp59_;
			gchar* _tmp60_;
			GMatchInfo* match = NULL;
			gboolean _tmp61_ = FALSE;
			GeeHashMap* _tmp62_;
			gpointer _tmp63_;
			GRegex* _tmp64_;
			const gchar* _tmp65_;
			GMatchInfo* _tmp66_ = NULL;
			gboolean _tmp67_;
			gboolean _tmp68_;
			gboolean _tmp184_ = FALSE;
			gboolean _tmp185_ = FALSE;
			const gchar* _tmp186_;
			gint _tmp187_;
			gint _tmp188_;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp49_ = dis;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp50_ = g_data_input_stream_read_line (_tmp49_, NULL, NULL, &_inner_error_);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp48_ = _tmp50_;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (item_basepath);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (item_status);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (item_disk_path);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (item_path);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (dis);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (_tmp36_);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (file);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (line);
#line 1505 "RsyncTask.c"
				goto __catch62_g_error;
			}
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp51_ = _tmp48_;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp48_ = NULL;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (line);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			line = _tmp51_;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp52_ = line;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (!(_tmp52_ != NULL)) {
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (_tmp48_);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				break;
#line 1524 "RsyncTask.c"
			}
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp53_ = ((AsyncTask*) self)->prg_count;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			((AsyncTask*) self)->prg_count = _tmp53_ + 1;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp54_ = line;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp55_ = string_strip (_tmp54_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp56_ = _tmp55_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp57_ = strlen (_tmp56_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp58_ = _tmp57_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp59_ = _tmp58_ == 0;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (_tmp56_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (_tmp59_) {
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (_tmp48_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				continue;
#line 1550 "RsyncTask.c"
			}
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp60_ = g_strdup ("");
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (item_path);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			item_path = _tmp60_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp62_ = self->priv->regex_list;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp63_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp62_, "created");
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp64_ = (GRegex*) _tmp63_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp65_ = line;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp67_ = g_regex_match (_tmp64_, _tmp65_, 0, &_tmp66_);
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_match_info_unref0 (match);
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			match = _tmp66_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp68_ = _tmp67_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp64_);
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (_tmp68_) {
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp61_ = TRUE;
#line 1580 "RsyncTask.c"
			} else {
				GeeHashMap* _tmp69_;
				gpointer _tmp70_;
				GRegex* _tmp71_;
				const gchar* _tmp72_;
				GMatchInfo* _tmp73_ = NULL;
				gboolean _tmp74_;
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp69_ = self->priv->regex_list;
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, "log-created");
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp71_ = (GRegex*) _tmp70_;
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp72_ = line;
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp74_ = g_regex_match (_tmp71_, _tmp72_, 0, &_tmp73_);
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_match_info_unref0 (match);
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				match = _tmp73_;
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp61_ = _tmp74_;
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_regex_unref0 (_tmp71_);
#line 1606 "RsyncTask.c"
			}
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (_tmp61_) {
#line 1610 "RsyncTask.c"
				GDataOutputStream* _tmp75_;
				GMatchInfo* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				gchar** _tmp83_;
				gchar** _tmp84_;
				gchar** _tmp85_;
				gint _tmp85__length1;
				const gchar* _tmp86_;
				gchar* _tmp87_;
				gchar* _tmp88_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp75_ = dos_changes;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				if (_tmp75_ != NULL) {
#line 1626 "RsyncTask.c"
					GDataOutputStream* _tmp76_;
					const gchar* _tmp77_;
					gchar* _tmp78_;
					gchar* _tmp79_;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp76_ = dos_changes;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp77_ = line;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp78_ = g_strdup_printf ("%s\n", _tmp77_);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp79_ = _tmp78_;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					g_data_output_stream_put_string (_tmp76_, _tmp79_, NULL, &_inner_error_);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (_tmp79_);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_match_info_unref0 (match);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (_tmp48_);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (item_basepath);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (item_status);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (item_disk_path);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (item_path);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_object_unref0 (dis);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_object_unref0 (_tmp36_);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_object_unref0 (file);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (line);
#line 1665 "RsyncTask.c"
						goto __catch62_g_error;
					}
				}
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp80_ = match;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp81_ = g_match_info_fetch (_tmp80_, 3);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp82_ = _tmp81_;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp84_ = _tmp83_ = g_strsplit (_tmp82_, " -> ", 0);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp85_ = _tmp84_;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp85__length1 = _vala_array_length (_tmp83_);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp86_ = _tmp85_[0];
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp87_ = string_strip (_tmp86_);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (item_path);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				item_path = _tmp87_;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp85_ = (_vala_array_free (_tmp85_, _tmp85__length1, (GDestroyNotify) g_free), NULL);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (_tmp82_);
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp88_ = g_strdup ("created");
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (item_status);
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				item_status = _tmp88_;
#line 1699 "RsyncTask.c"
			} else {
				gboolean _tmp89_ = FALSE;
				GeeHashMap* _tmp90_;
				gpointer _tmp91_;
				GRegex* _tmp92_;
				const gchar* _tmp93_;
				GMatchInfo* _tmp94_ = NULL;
				gboolean _tmp95_;
				gboolean _tmp96_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp90_ = self->priv->regex_list;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp91_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp90_, "log-deleted");
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp92_ = (GRegex*) _tmp91_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp93_ = line;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp95_ = g_regex_match (_tmp92_, _tmp93_, 0, &_tmp94_);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_match_info_unref0 (match);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				match = _tmp94_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp96_ = _tmp95_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_regex_unref0 (_tmp92_);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				if (_tmp96_) {
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp89_ = TRUE;
#line 1731 "RsyncTask.c"
				} else {
					GeeHashMap* _tmp97_;
					gpointer _tmp98_;
					GRegex* _tmp99_;
					const gchar* _tmp100_;
					GMatchInfo* _tmp101_ = NULL;
					gboolean _tmp102_;
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp97_ = self->priv->regex_list;
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp98_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp97_, "deleted");
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp99_ = (GRegex*) _tmp98_;
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp100_ = line;
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp102_ = g_regex_match (_tmp99_, _tmp100_, 0, &_tmp101_);
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_match_info_unref0 (match);
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					match = _tmp101_;
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp89_ = _tmp102_;
#line 337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_regex_unref0 (_tmp99_);
#line 1757 "RsyncTask.c"
				}
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				if (_tmp89_) {
#line 1761 "RsyncTask.c"
					GDataOutputStream* _tmp103_;
					GMatchInfo* _tmp108_;
					gchar* _tmp109_;
					gchar* _tmp110_;
					gchar** _tmp111_;
					gchar** _tmp112_;
					gchar** _tmp113_;
					gint _tmp113__length1;
					const gchar* _tmp114_;
					gchar* _tmp115_;
					gchar* _tmp116_;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp103_ = dos_changes;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					if (_tmp103_ != NULL) {
#line 1777 "RsyncTask.c"
						GDataOutputStream* _tmp104_;
						const gchar* _tmp105_;
						gchar* _tmp106_;
						gchar* _tmp107_;
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp104_ = dos_changes;
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp105_ = line;
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp106_ = g_strdup_printf ("%s\n", _tmp105_);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp107_ = _tmp106_;
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						g_data_output_stream_put_string (_tmp104_, _tmp107_, NULL, &_inner_error_);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (_tmp107_);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_match_info_unref0 (match);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (_tmp48_);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (item_basepath);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (item_status);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (item_disk_path);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (item_path);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_object_unref0 (dis);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_object_unref0 (_tmp36_);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_object_unref0 (file);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (line);
#line 1816 "RsyncTask.c"
							goto __catch62_g_error;
						}
					}
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp108_ = match;
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp109_ = g_match_info_fetch (_tmp108_, 1);
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp110_ = _tmp109_;
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp112_ = _tmp111_ = g_strsplit (_tmp110_, " -> ", 0);
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp113_ = _tmp112_;
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp113__length1 = _vala_array_length (_tmp111_);
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp114_ = _tmp113_[0];
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp115_ = string_strip (_tmp114_);
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (item_path);
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					item_path = _tmp115_;
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp113_ = (_vala_array_free (_tmp113_, _tmp113__length1, (GDestroyNotify) g_free), NULL);
#line 345 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (_tmp110_);
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp116_ = g_strdup ("deleted");
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (item_status);
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					item_status = _tmp116_;
#line 1850 "RsyncTask.c"
				} else {
					gboolean _tmp117_ = FALSE;
					GeeHashMap* _tmp118_;
					gpointer _tmp119_;
					GRegex* _tmp120_;
					const gchar* _tmp121_;
					GMatchInfo* _tmp122_ = NULL;
					gboolean _tmp123_;
					gboolean _tmp124_;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp118_ = self->priv->regex_list;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp119_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp118_, "modified");
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp120_ = (GRegex*) _tmp119_;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp121_ = line;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp123_ = g_regex_match (_tmp120_, _tmp121_, 0, &_tmp122_);
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_match_info_unref0 (match);
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					match = _tmp122_;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp124_ = _tmp123_;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_regex_unref0 (_tmp120_);
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					if (_tmp124_) {
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp117_ = TRUE;
#line 1882 "RsyncTask.c"
					} else {
						GeeHashMap* _tmp125_;
						gpointer _tmp126_;
						GRegex* _tmp127_;
						const gchar* _tmp128_;
						GMatchInfo* _tmp129_ = NULL;
						gboolean _tmp130_;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp125_ = self->priv->regex_list;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp126_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp125_, "log-modified");
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp127_ = (GRegex*) _tmp126_;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp128_ = line;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp130_ = g_regex_match (_tmp127_, _tmp128_, 0, &_tmp129_);
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_match_info_unref0 (match);
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						match = _tmp129_;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp117_ = _tmp130_;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_regex_unref0 (_tmp127_);
#line 1908 "RsyncTask.c"
					}
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					if (_tmp117_) {
#line 1912 "RsyncTask.c"
						GDataOutputStream* _tmp131_;
						GMatchInfo* _tmp136_;
						gchar* _tmp137_;
						gchar* _tmp138_;
						gchar** _tmp139_;
						gchar** _tmp140_;
						gchar** _tmp141_;
						gint _tmp141__length1;
						const gchar* _tmp142_;
						gchar* _tmp143_;
						GMatchInfo* _tmp144_;
						gchar* _tmp145_;
						gchar* _tmp146_;
						gboolean _tmp147_;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp131_ = dos_changes;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						if (_tmp131_ != NULL) {
#line 1931 "RsyncTask.c"
							GDataOutputStream* _tmp132_;
							const gchar* _tmp133_;
							gchar* _tmp134_;
							gchar* _tmp135_;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp132_ = dos_changes;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp133_ = line;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp134_ = g_strdup_printf ("%s\n", _tmp133_);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp135_ = _tmp134_;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							g_data_output_stream_put_string (_tmp132_, _tmp135_, NULL, &_inner_error_);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (_tmp135_);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_match_info_unref0 (match);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (_tmp48_);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (item_basepath);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (item_status);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (item_disk_path);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (item_path);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_object_unref0 (dis);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_object_unref0 (_tmp36_);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_object_unref0 (file);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (line);
#line 1970 "RsyncTask.c"
								goto __catch62_g_error;
							}
						}
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp136_ = match;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp137_ = g_match_info_fetch (_tmp136_, 12);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp138_ = _tmp137_;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp140_ = _tmp139_ = g_strsplit (_tmp138_, " -> ", 0);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp141_ = _tmp140_;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp141__length1 = _vala_array_length (_tmp139_);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp142_ = _tmp141_[0];
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp143_ = string_strip (_tmp142_);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (item_path);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						item_path = _tmp143_;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp141_ = (_vala_array_free (_tmp141_, _tmp141__length1, (GDestroyNotify) g_free), NULL);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (_tmp138_);
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp144_ = match;
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp145_ = g_match_info_fetch (_tmp144_, 3);
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp146_ = _tmp145_;
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp147_ = g_strcmp0 (_tmp146_, "c") == 0;
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (_tmp146_);
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						if (_tmp147_) {
#line 2010 "RsyncTask.c"
							gchar* _tmp148_;
#line 368 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp148_ = g_strdup ("checksum");
#line 368 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (item_status);
#line 368 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							item_status = _tmp148_;
#line 2018 "RsyncTask.c"
						} else {
							GMatchInfo* _tmp149_;
							gchar* _tmp150_;
							gchar* _tmp151_;
							gboolean _tmp152_;
#line 370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp149_ = match;
#line 370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp150_ = g_match_info_fetch (_tmp149_, 4);
#line 370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp151_ = _tmp150_;
#line 370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp152_ = g_strcmp0 (_tmp151_, "s") == 0;
#line 370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (_tmp151_);
#line 370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							if (_tmp152_) {
#line 2036 "RsyncTask.c"
								gchar* _tmp153_;
#line 371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp153_ = g_strdup ("size");
#line 371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (item_status);
#line 371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								item_status = _tmp153_;
#line 2044 "RsyncTask.c"
							} else {
								GMatchInfo* _tmp154_;
								gchar* _tmp155_;
								gchar* _tmp156_;
								gboolean _tmp157_;
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp154_ = match;
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp155_ = g_match_info_fetch (_tmp154_, 5);
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp156_ = _tmp155_;
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp157_ = g_strcmp0 (_tmp156_, "t") == 0;
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (_tmp156_);
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								if (_tmp157_) {
#line 2062 "RsyncTask.c"
									gchar* _tmp158_;
#line 374 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp158_ = g_strdup ("timestamp");
#line 374 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_g_free0 (item_status);
#line 374 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									item_status = _tmp158_;
#line 2070 "RsyncTask.c"
								} else {
									GMatchInfo* _tmp159_;
									gchar* _tmp160_;
									gchar* _tmp161_;
									gboolean _tmp162_;
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp159_ = match;
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp160_ = g_match_info_fetch (_tmp159_, 6);
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp161_ = _tmp160_;
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp162_ = g_strcmp0 (_tmp161_, "p") == 0;
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_g_free0 (_tmp161_);
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									if (_tmp162_) {
#line 2088 "RsyncTask.c"
										gchar* _tmp163_;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp163_ = g_strdup ("permissions");
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_g_free0 (item_status);
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										item_status = _tmp163_;
#line 2096 "RsyncTask.c"
									} else {
										GMatchInfo* _tmp164_;
										gchar* _tmp165_;
										gchar* _tmp166_;
										gboolean _tmp167_;
#line 379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp164_ = match;
#line 379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp165_ = g_match_info_fetch (_tmp164_, 7);
#line 379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp166_ = _tmp165_;
#line 379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp167_ = g_strcmp0 (_tmp166_, "o") == 0;
#line 379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_g_free0 (_tmp166_);
#line 379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										if (_tmp167_) {
#line 2114 "RsyncTask.c"
											gchar* _tmp168_;
#line 380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_tmp168_ = g_strdup ("owner");
#line 380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_g_free0 (item_status);
#line 380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											item_status = _tmp168_;
#line 2122 "RsyncTask.c"
										} else {
											GMatchInfo* _tmp169_;
											gchar* _tmp170_;
											gchar* _tmp171_;
											gboolean _tmp172_;
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_tmp169_ = match;
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_tmp170_ = g_match_info_fetch (_tmp169_, 8);
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_tmp171_ = _tmp170_;
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_tmp172_ = g_strcmp0 (_tmp171_, "g") == 0;
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_g_free0 (_tmp171_);
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											if (_tmp172_) {
#line 2140 "RsyncTask.c"
												gchar* _tmp173_;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
												_tmp173_ = g_strdup ("group");
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
												_g_free0 (item_status);
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
												item_status = _tmp173_;
#line 2148 "RsyncTask.c"
											}
										}
									}
								}
							}
						}
					} else {
						GeeHashMap* _tmp174_;
						gpointer _tmp175_;
						GRegex* _tmp176_;
						const gchar* _tmp177_;
						GMatchInfo* _tmp178_ = NULL;
						gboolean _tmp179_;
						gboolean _tmp180_;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp174_ = self->priv->regex_list;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp175_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp174_, "log-unchanged");
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp176_ = (GRegex*) _tmp175_;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp177_ = line;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp179_ = g_regex_match (_tmp176_, _tmp177_, 0, &_tmp178_);
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_match_info_unref0 (match);
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						match = _tmp178_;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp180_ = _tmp179_;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_regex_unref0 (_tmp176_);
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						if (_tmp180_) {
#line 2183 "RsyncTask.c"
						} else {
							const gchar* _tmp181_;
							gchar* _tmp182_;
							gchar* _tmp183_;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp181_ = line;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp182_ = g_strdup_printf ("not-matched: %s", _tmp181_);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp183_ = _tmp182_;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							tee_jee_logging_log_debug (_tmp183_);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (_tmp183_);
#line 2198 "RsyncTask.c"
						}
					}
				}
			}
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp186_ = item_path;
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp187_ = strlen (_tmp186_);
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp188_ = _tmp187_;
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (_tmp188_ > 0) {
#line 2211 "RsyncTask.c"
				const gchar* _tmp189_;
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp189_ = item_path;
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp185_ = g_strcmp0 (_tmp189_, "/./") != 0;
#line 2217 "RsyncTask.c"
			} else {
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp185_ = FALSE;
#line 2221 "RsyncTask.c"
			}
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (_tmp185_) {
#line 2225 "RsyncTask.c"
				const gchar* _tmp190_;
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp190_ = item_path;
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp184_ = g_strcmp0 (_tmp190_, "./") != 0;
#line 2231 "RsyncTask.c"
			} else {
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp184_ = FALSE;
#line 2235 "RsyncTask.c"
			}
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (_tmp184_) {
#line 2239 "RsyncTask.c"
				const gchar* _tmp191_;
				const gchar* _tmp192_;
				gchar* _tmp193_;
				FileItem* item = NULL;
				const gchar* _tmp194_;
				FileItem* _tmp195_;
				FileItem* _tmp196_;
				const gchar* _tmp197_;
				gchar* _tmp198_;
				GeeArrayList* _tmp199_;
				FileItem* _tmp200_;
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp191_ = item_basepath;
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp192_ = item_path;
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp193_ = tee_jee_file_system_path_combine (_tmp191_, _tmp192_);
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (item_disk_path);
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				item_disk_path = _tmp193_;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp194_ = item_disk_path;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp195_ = file_item_new_from_disk_path_with_basic_info (_tmp194_);
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				item = _tmp195_;
#line 398 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp196_ = item;
#line 398 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp197_ = item_status;
#line 398 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp198_ = g_strdup (_tmp197_);
#line 398 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (_tmp196_->file_status);
#line 398 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp196_->file_status = _tmp198_;
#line 399 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp199_ = list;
#line 399 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp200_ = item;
#line 399 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp199_, _tmp200_);
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_object_unref0 (item);
#line 2285 "RsyncTask.c"
			}
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_match_info_unref0 (match);
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (_tmp48_);
#line 2291 "RsyncTask.c"
		}
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (item_basepath);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (item_status);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (item_disk_path);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (item_path);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_object_unref0 (dis);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_object_unref0 (_tmp36_);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_object_unref0 (file);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (line);
#line 2309 "RsyncTask.c"
	}
	goto __finally62;
	__catch62_g_error:
	{
		GError* e = NULL;
		GError* _tmp201_;
		const gchar* _tmp202_;
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		e = _inner_error_;
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_inner_error_ = NULL;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp201_ = e;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp202_ = _tmp201_->message;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		tee_jee_logging_log_error (_tmp202_, FALSE, FALSE);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_error_free0 (e);
#line 2329 "RsyncTask.c"
	}
	__finally62:
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_object_unref0 (dos_changes);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (log_file);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_object_unref0 (list);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		return NULL;
#line 2346 "RsyncTask.c"
	}
#line 408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp203_ = dos_changes;
#line 408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp203_ != NULL) {
#line 2352 "RsyncTask.c"
		const gchar* _tmp204_;
		gchar* _tmp205_;
		gchar* _tmp206_;
		const gchar* _tmp207_;
#line 410 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp204_ = log_file_path;
#line 410 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp205_ = g_strdup_printf ("Archiving: %s", _tmp204_);
#line 410 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp206_ = _tmp205_;
#line 410 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		tee_jee_logging_log_msg (_tmp206_, FALSE);
#line 410 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp206_);
#line 411 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp207_ = log_file_path;
#line 411 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		tee_jee_file_system_file_gzip (_tmp207_);
#line 2371 "RsyncTask.c"
	}
#line 414 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	tee_jee_logging_log_debug ("RsyncTask: parse_log(): exit");
#line 416 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	result = list;
#line 416 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_object_unref0 (dos_changes);
#line 416 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (log_file);
#line 416 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	return result;
#line 2383 "RsyncTask.c"
}


void rsync_task_execute (RsyncTask* self) {
	AppStatus _tmp0_;
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	tee_jee_logging_log_debug ("RsyncTask:execute()");
#line 425 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	rsync_task_prepare (self);
#line 433 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	async_task_begin ((AsyncTask*) self);
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = ((AsyncTask*) self)->status;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp0_ == APP_STATUS_RUNNING) {
#line 2401 "RsyncTask.c"
	}
}


static void rsync_task_real_parse_stdout_line (AsyncTask* base, const gchar* out_line) {
	RsyncTask * self;
	gboolean _tmp0_;
	const gchar* _tmp1_;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self = (RsyncTask*) base;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_if_fail (out_line != NULL);
#line 442 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = ((AsyncTask*) self)->is_terminated;
#line 442 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp0_) {
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		return;
#line 2420 "RsyncTask.c"
	}
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = out_line;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	rsync_task_update_progress_parse_console_output (self, _tmp1_);
#line 2426 "RsyncTask.c"
}


static void rsync_task_real_parse_stderr_line (AsyncTask* base, const gchar* err_line) {
	RsyncTask * self;
	gboolean _tmp0_;
	const gchar* _tmp1_;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self = (RsyncTask*) base;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_if_fail (err_line != NULL);
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = ((AsyncTask*) self)->is_terminated;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp0_) {
#line 451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		return;
#line 2444 "RsyncTask.c"
	}
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = err_line;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	rsync_task_update_progress_parse_console_output (self, _tmp1_);
#line 2450 "RsyncTask.c"
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_;
	gint64 _tmp1_;
#line 687 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 2468 "RsyncTask.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2487 "RsyncTask.c"
	} else {
		const gchar* _tmp2_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
#line 2494 "RsyncTask.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2500 "RsyncTask.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = replacement;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 2510 "RsyncTask.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 2514 "RsyncTask.c"
		gchar* _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp5_ = g_strdup (self);
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 2522 "RsyncTask.c"
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = old;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp9_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp8_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		regex = _tmp10_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2554 "RsyncTask.c"
				goto __catch63_g_regex_error;
			}
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 2563 "RsyncTask.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = regex;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp13_ = replacement;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = _tmp14_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2579 "RsyncTask.c"
				goto __catch63_g_regex_error;
			}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 2590 "RsyncTask.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = _tmp11_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = NULL;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp15_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp11_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 2604 "RsyncTask.c"
	}
	goto __finally63;
	__catch63_g_regex_error:
	{
		GError* e = NULL;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1423 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 2618 "RsyncTask.c"
	}
	__finally63:
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return NULL;
#line 2629 "RsyncTask.c"
	}
}


gboolean rsync_task_update_progress_parse_console_output (RsyncTask* self, const gchar* line) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	GMatchInfo* match = NULL;
	GeeHashMap* _tmp10_;
	gpointer _tmp11_;
	GRegex* _tmp12_;
	const gchar* _tmp13_;
	GMatchInfo* _tmp14_ = NULL;
	gboolean _tmp15_;
	gboolean _tmp16_;
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = line;
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp1_ == NULL) {
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp0_ = TRUE;
#line 2658 "RsyncTask.c"
	} else {
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp2_ = line;
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp3_ = strlen (_tmp2_);
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp4_ = _tmp3_;
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp0_ = _tmp4_ == 0;
#line 2671 "RsyncTask.c"
	}
#line 458 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp0_) {
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		result = TRUE;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		return result;
#line 2679 "RsyncTask.c"
	}
#line 462 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp5_ = self->status_line_count;
#line 462 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->status_line_count = _tmp5_ + 1;
#line 464 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp6_ = ((AsyncTask*) self)->prg_count_total;
#line 464 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp6_ > ((gint64) 0)) {
#line 2689 "RsyncTask.c"
		gint64 _tmp7_;
		gint64 _tmp8_;
		gint64 _tmp9_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp7_ = self->status_line_count;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		((AsyncTask*) self)->prg_count = _tmp7_;
#line 466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp8_ = ((AsyncTask*) self)->prg_count;
#line 466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp9_ = ((AsyncTask*) self)->prg_count_total;
#line 466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		((AsyncTask*) self)->progress = (_tmp8_ * 1.0) / _tmp9_;
#line 2703 "RsyncTask.c"
	}
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp10_ = self->priv->regex_list;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, "created");
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp12_ = (GRegex*) _tmp11_;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp13_ = line;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp15_ = g_regex_match (_tmp12_, _tmp13_, 0, &_tmp14_);
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_match_info_unref0 (match);
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	match = _tmp14_;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp16_ = _tmp15_;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_regex_unref0 (_tmp12_);
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp16_) {
#line 2725 "RsyncTask.c"
		gint64 _tmp17_;
		GMatchInfo* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar** _tmp21_;
		gchar** _tmp22_;
		gchar** _tmp23_;
		gint _tmp23__length1;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		GString* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp17_ = self->count_created;
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		self->count_created = _tmp17_ + 1;
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp18_ = match;
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp19_ = g_match_info_fetch (_tmp18_, 3);
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp20_ = _tmp19_;
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp22_ = _tmp21_ = g_strsplit (_tmp20_, " -> ", 0);
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp23_ = _tmp22_;
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp23__length1 = _vala_array_length (_tmp21_);
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp24_ = _tmp23_[0];
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp25_ = string_strip (_tmp24_);
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (((AsyncTask*) self)->status_line);
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		((AsyncTask*) self)->status_line = _tmp25_;
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 484 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp20_);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp26_ = self->log;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp27_ = line;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp28_ = g_strconcat (_tmp27_, "\n", NULL);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp29_ = _tmp28_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		g_string_append (_tmp26_, _tmp29_);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (_tmp29_);
#line 2780 "RsyncTask.c"
	} else {
		GeeHashMap* _tmp30_;
		gpointer _tmp31_;
		GRegex* _tmp32_;
		const gchar* _tmp33_;
		GMatchInfo* _tmp34_ = NULL;
		gboolean _tmp35_;
		gboolean _tmp36_;
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp30_ = self->priv->regex_list;
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp30_, "deleted");
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp32_ = (GRegex*) _tmp31_;
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp33_ = line;
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp35_ = g_regex_match (_tmp32_, _tmp33_, 0, &_tmp34_);
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_match_info_unref0 (match);
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		match = _tmp34_;
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp36_ = _tmp35_;
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp32_);
#line 487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		if (_tmp36_) {
#line 2809 "RsyncTask.c"
			gint64 _tmp37_;
			GMatchInfo* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar** _tmp41_;
			gchar** _tmp42_;
			gchar** _tmp43_;
			gint _tmp43__length1;
			const gchar* _tmp44_;
			gchar* _tmp45_;
			GString* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
#line 491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp37_ = self->count_deleted;
#line 491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			self->count_deleted = _tmp37_ + 1;
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp38_ = match;
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp39_ = g_match_info_fetch (_tmp38_, 1);
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp40_ = _tmp39_;
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp42_ = _tmp41_ = g_strsplit (_tmp40_, " -> ", 0);
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp43_ = _tmp42_;
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp43__length1 = _vala_array_length (_tmp41_);
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp44_ = _tmp43_[0];
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp45_ = string_strip (_tmp44_);
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (((AsyncTask*) self)->status_line);
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			((AsyncTask*) self)->status_line = _tmp45_;
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp43_ = (_vala_array_free (_tmp43_, _tmp43__length1, (GDestroyNotify) g_free), NULL);
#line 492 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (_tmp40_);
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp46_ = self->log;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp47_ = line;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp48_ = g_strconcat (_tmp47_, "\n", NULL);
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp49_ = _tmp48_;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			g_string_append (_tmp46_, _tmp49_);
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_free0 (_tmp49_);
#line 2864 "RsyncTask.c"
		} else {
			GeeHashMap* _tmp50_;
			gpointer _tmp51_;
			GRegex* _tmp52_;
			const gchar* _tmp53_;
			GMatchInfo* _tmp54_ = NULL;
			gboolean _tmp55_;
			gboolean _tmp56_;
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp50_ = self->priv->regex_list;
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp51_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp50_, "unchanged");
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp52_ = (GRegex*) _tmp51_;
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp53_ = line;
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp55_ = g_regex_match (_tmp52_, _tmp53_, 0, &_tmp54_);
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_match_info_unref0 (match);
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			match = _tmp54_;
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_tmp56_ = _tmp55_;
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp52_);
#line 495 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
			if (_tmp56_) {
#line 2893 "RsyncTask.c"
				gint64 _tmp57_;
				GMatchInfo* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar** _tmp61_;
				gchar** _tmp62_;
				gchar** _tmp63_;
				gint _tmp63__length1;
				const gchar* _tmp64_;
				gchar* _tmp65_;
#line 499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp57_ = self->count_unchanged;
#line 499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				self->count_unchanged = _tmp57_ + 1;
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp58_ = match;
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp59_ = g_match_info_fetch (_tmp58_, 3);
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp60_ = _tmp59_;
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp62_ = _tmp61_ = g_strsplit (_tmp60_, " -> ", 0);
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp63_ = _tmp62_;
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp63__length1 = _vala_array_length (_tmp61_);
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp64_ = _tmp63_[0];
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp65_ = string_strip (_tmp64_);
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (((AsyncTask*) self)->status_line);
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				((AsyncTask*) self)->status_line = _tmp65_;
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp63_ = (_vala_array_free (_tmp63_, _tmp63__length1, (GDestroyNotify) g_free), NULL);
#line 500 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_free0 (_tmp60_);
#line 2932 "RsyncTask.c"
			} else {
				GeeHashMap* _tmp66_;
				gpointer _tmp67_;
				GRegex* _tmp68_;
				const gchar* _tmp69_;
				GMatchInfo* _tmp70_ = NULL;
				gboolean _tmp71_;
				gboolean _tmp72_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp66_ = self->priv->regex_list;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp67_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp66_, "modified");
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp68_ = (GRegex*) _tmp67_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp69_ = line;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp71_ = g_regex_match (_tmp68_, _tmp69_, 0, &_tmp70_);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_match_info_unref0 (match);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				match = _tmp70_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_tmp72_ = _tmp71_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				_g_regex_unref0 (_tmp68_);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
				if (_tmp72_) {
#line 2961 "RsyncTask.c"
					gint64 _tmp73_;
					GMatchInfo* _tmp74_;
					gchar* _tmp75_;
					gchar* _tmp76_;
					gchar** _tmp77_;
					gchar** _tmp78_;
					gchar** _tmp79_;
					gint _tmp79__length1;
					const gchar* _tmp80_;
					gchar* _tmp81_;
					GString* _tmp82_;
					const gchar* _tmp83_;
					gchar* _tmp84_;
					gchar* _tmp85_;
					GMatchInfo* _tmp86_;
					gchar* _tmp87_;
					gchar* _tmp88_;
					gboolean _tmp89_;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp73_ = self->count_modified;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					self->count_modified = _tmp73_ + 1;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp74_ = match;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp75_ = g_match_info_fetch (_tmp74_, 12);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp76_ = _tmp75_;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp78_ = _tmp77_ = g_strsplit (_tmp76_, " -> ", 0);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp79_ = _tmp78_;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp79__length1 = _vala_array_length (_tmp77_);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp80_ = _tmp79_[0];
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp81_ = string_strip (_tmp80_);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (((AsyncTask*) self)->status_line);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					((AsyncTask*) self)->status_line = _tmp81_;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp79_ = (_vala_array_free (_tmp79_, _tmp79__length1, (GDestroyNotify) g_free), NULL);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (_tmp76_);
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp82_ = self->log;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp83_ = line;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp84_ = g_strconcat (_tmp83_, "\n", NULL);
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp85_ = _tmp84_;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					g_string_append (_tmp82_, _tmp85_);
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (_tmp85_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp86_ = match;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp87_ = g_match_info_fetch (_tmp86_, 3);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp88_ = _tmp87_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp89_ = g_strcmp0 (_tmp88_, "c") == 0;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_free0 (_tmp88_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					if (_tmp89_) {
#line 3032 "RsyncTask.c"
						gint64 _tmp90_;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp90_ = self->count_checksum;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						self->count_checksum = _tmp90_ + 1;
#line 3038 "RsyncTask.c"
					} else {
						GMatchInfo* _tmp91_;
						gchar* _tmp92_;
						gchar* _tmp93_;
						gboolean _tmp94_;
#line 513 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp91_ = match;
#line 513 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp92_ = g_match_info_fetch (_tmp91_, 4);
#line 513 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp93_ = _tmp92_;
#line 513 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp94_ = g_strcmp0 (_tmp93_, "s") == 0;
#line 513 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (_tmp93_);
#line 513 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						if (_tmp94_) {
#line 3056 "RsyncTask.c"
							gint64 _tmp95_;
#line 514 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp95_ = self->count_size;
#line 514 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							self->count_size = _tmp95_ + 1;
#line 3062 "RsyncTask.c"
						} else {
							GMatchInfo* _tmp96_;
							gchar* _tmp97_;
							gchar* _tmp98_;
							gboolean _tmp99_;
#line 516 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp96_ = match;
#line 516 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp97_ = g_match_info_fetch (_tmp96_, 5);
#line 516 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp98_ = _tmp97_;
#line 516 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_tmp99_ = g_strcmp0 (_tmp98_, "t") == 0;
#line 516 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							_g_free0 (_tmp98_);
#line 516 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
							if (_tmp99_) {
#line 3080 "RsyncTask.c"
								gint64 _tmp100_;
#line 517 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp100_ = self->count_timestamp;
#line 517 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								self->count_timestamp = _tmp100_ + 1;
#line 3086 "RsyncTask.c"
							} else {
								GMatchInfo* _tmp101_;
								gchar* _tmp102_;
								gchar* _tmp103_;
								gboolean _tmp104_;
#line 519 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp101_ = match;
#line 519 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp102_ = g_match_info_fetch (_tmp101_, 6);
#line 519 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp103_ = _tmp102_;
#line 519 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_tmp104_ = g_strcmp0 (_tmp103_, "p") == 0;
#line 519 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								_g_free0 (_tmp103_);
#line 519 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
								if (_tmp104_) {
#line 3104 "RsyncTask.c"
									gint64 _tmp105_;
#line 520 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp105_ = self->count_permissions;
#line 520 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									self->count_permissions = _tmp105_ + 1;
#line 3110 "RsyncTask.c"
								} else {
									GMatchInfo* _tmp106_;
									gchar* _tmp107_;
									gchar* _tmp108_;
									gboolean _tmp109_;
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp106_ = match;
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp107_ = g_match_info_fetch (_tmp106_, 7);
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp108_ = _tmp107_;
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_tmp109_ = g_strcmp0 (_tmp108_, "o") == 0;
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									_g_free0 (_tmp108_);
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
									if (_tmp109_) {
#line 3128 "RsyncTask.c"
										gint64 _tmp110_;
#line 523 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp110_ = self->count_owner;
#line 523 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										self->count_owner = _tmp110_ + 1;
#line 3134 "RsyncTask.c"
									} else {
										GMatchInfo* _tmp111_;
										gchar* _tmp112_;
										gchar* _tmp113_;
										gboolean _tmp114_;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp111_ = match;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp112_ = g_match_info_fetch (_tmp111_, 8);
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp113_ = _tmp112_;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_tmp114_ = g_strcmp0 (_tmp113_, "g") == 0;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										_g_free0 (_tmp113_);
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
										if (_tmp114_) {
#line 3152 "RsyncTask.c"
											gint64 _tmp115_;
#line 526 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_tmp115_ = self->count_group;
#line 526 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											self->count_group = _tmp115_ + 1;
#line 3158 "RsyncTask.c"
										} else {
											gint64 _tmp116_;
#line 529 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											_tmp116_ = self->count_unchanged;
#line 529 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
											self->count_unchanged = _tmp116_ + 1;
#line 3165 "RsyncTask.c"
										}
									}
								}
							}
						}
					}
				} else {
					GeeHashMap* _tmp117_;
					gpointer _tmp118_;
					GRegex* _tmp119_;
					const gchar* _tmp120_;
					GMatchInfo* _tmp121_ = NULL;
					gboolean _tmp122_;
					gboolean _tmp123_;
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp117_ = self->priv->regex_list;
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp118_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp117_, "total-size");
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp119_ = (GRegex*) _tmp118_;
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp120_ = line;
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp122_ = g_regex_match (_tmp119_, _tmp120_, 0, &_tmp121_);
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_match_info_unref0 (match);
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					match = _tmp121_;
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_tmp123_ = _tmp122_;
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					_g_regex_unref0 (_tmp119_);
#line 532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
					if (_tmp123_) {
#line 3200 "RsyncTask.c"
						GMatchInfo* _tmp124_;
						gchar* _tmp125_;
						gchar* _tmp126_;
						gchar* _tmp127_;
						gchar* _tmp128_;
						gint64 _tmp129_;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp124_ = match;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp125_ = g_match_info_fetch (_tmp124_, 1);
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp126_ = _tmp125_;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp127_ = string_replace (_tmp126_, ",", "");
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp128_ = _tmp127_;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_tmp129_ = int64_parse (_tmp128_);
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						self->total_size = _tmp129_;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (_tmp128_);
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
						_g_free0 (_tmp126_);
#line 3225 "RsyncTask.c"
					} else {
					}
				}
			}
		}
	}
#line 539 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	result = TRUE;
#line 539 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_match_info_unref0 (match);
#line 539 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	return result;
#line 3238 "RsyncTask.c"
}


static void rsync_task_real_finish_task (AsyncTask* base) {
	RsyncTask * self;
	gboolean _tmp0_ = FALSE;
	AppStatus _tmp1_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GString* _tmp6_;
	const gchar* _tmp7_;
#line 542 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self = (RsyncTask*) base;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = ((AsyncTask*) self)->status;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp1_ != APP_STATUS_CANCELLED) {
#line 3257 "RsyncTask.c"
		AppStatus _tmp2_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp2_ = ((AsyncTask*) self)->status;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp0_ = _tmp2_ != APP_STATUS_PASSWORD_REQUIRED;
#line 3263 "RsyncTask.c"
	} else {
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp0_ = FALSE;
#line 3267 "RsyncTask.c"
	}
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp0_) {
#line 545 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		((AsyncTask*) self)->status = APP_STATUS_FINISHED;
#line 3273 "RsyncTask.c"
	}
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp3_ = self->rsync_log_file;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp4_ = g_strconcat (_tmp3_, "-changes", NULL);
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp5_ = _tmp4_;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp6_ = self->log;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp7_ = _tmp6_->str;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	tee_jee_file_system_file_write (_tmp5_, _tmp7_);
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (_tmp5_);
#line 3289 "RsyncTask.c"
}


gint rsync_task_read_status (RsyncTask* self) {
	gint result = 0;
	gchar* status_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* f = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = ((AsyncTask*) self)->working_dir;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/status", NULL);
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	status_file = _tmp1_;
#line 553 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp2_ = status_file;
#line 553 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 553 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	f = _tmp3_;
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp4_ = f;
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	if (_tmp5_) {
#line 3323 "RsyncTask.c"
		gchar* txt = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
#line 555 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp6_ = status_file;
#line 555 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp7_ = tee_jee_file_system_file_read (_tmp6_);
#line 555 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		txt = _tmp7_;
#line 556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp8_ = txt;
#line 556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_tmp9_ = atoi (_tmp8_);
#line 556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		result = _tmp9_;
#line 556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (txt);
#line 556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_object_unref0 (f);
#line 556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		_g_free0 (status_file);
#line 556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
		return result;
#line 3349 "RsyncTask.c"
	}
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	result = -1;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_object_unref0 (f);
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (status_file);
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	return result;
#line 3359 "RsyncTask.c"
}


static void rsync_task_class_init (RsyncTaskClass * klass) {
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	rsync_task_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	g_type_class_add_private (klass, sizeof (RsyncTaskPrivate));
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask *, const gchar*)) rsync_task_real_parse_stdout_line;
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask *, const gchar*)) rsync_task_real_parse_stderr_line;
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask *)) rsync_task_real_finish_task;
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	G_OBJECT_CLASS (klass)->finalize = rsync_task_finalize;
#line 3376 "RsyncTask.c"
}


static void rsync_task_instance_init (RsyncTask * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->priv = RSYNC_TASK_GET_PRIVATE (self);
#line 34 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->delete_extra = TRUE;
#line 35 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->delete_after = FALSE;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->delete_excluded = FALSE;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->relative = FALSE;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->rsync_log_file = _tmp0_;
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp1_ = g_strdup ("");
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->exclude_from_file = _tmp1_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp2_ = g_strdup ("");
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->link_from_path = _tmp2_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp3_ = g_strdup ("");
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->source_path = _tmp3_;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_tmp4_ = g_strdup ("");
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->dest_path = _tmp4_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->verbose = TRUE;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->io_nice = TRUE;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->dry_run = FALSE;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->status_line_count = (gint64) 0;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self->total_size = (gint64) 0;
#line 3426 "RsyncTask.c"
}


static void rsync_task_finalize (GObject * obj) {
	RsyncTask * self;
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RSYNC_TASK, RsyncTask);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (self->rsync_log_file);
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (self->exclude_from_file);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (self->link_from_path);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (self->source_path);
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_free0 (self->dest_path);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_object_unref0 (self->priv->regex_list);
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	__g_queue_free__g_free0_0 (self->status_lines);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	_g_string_free0 (self->log);
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/RsyncTask.vala"
	G_OBJECT_CLASS (rsync_task_parent_class)->finalize (obj);
#line 3452 "RsyncTask.c"
}


GType rsync_task_get_type (void) {
	static volatile gsize rsync_task_type_id__volatile = 0;
	if (g_once_init_enter (&rsync_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RsyncTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rsync_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RsyncTask), 0, (GInstanceInitFunc) rsync_task_instance_init, NULL };
		GType rsync_task_type_id;
		rsync_task_type_id = g_type_register_static (TYPE_ASYNC_TASK, "RsyncTask", &g_define_type_info, 0);
		g_once_init_leave (&rsync_task_type_id__volatile, rsync_task_type_id);
	}
	return rsync_task_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



